///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//   c    
///////////////////////////////////////////////////////////////////////////////
#include "ADelayMeasurement.h"
#include "GreenwichFrame.h"
#include "Consts.h"
///////////////////////////////////////////////////////////////////////////////
// 
//-----------------------------------------------------------------------------
ADelayMeasurement::ADelayMeasurement() : AMeasurement(), 
     //       
     //     
                         TimePrec(0.01 * 1.e-3) 
  {
  }
//-----------------------------------------------------------------------------
//    t,       
// ,          
//-----------------------------------------------------------------------------
bool ADelayMeasurement::DetectPosition(ITraject &trj, TimeJD &t, 
                                       const IFrame *fr, Vect6 *f) const
  {
  Vect6 fo;
  Vect3 rc;
  double tau, tau1;
  GreenwichFrame gf;

  if (fr == 0)
    fr = &gf;

  if (f == 0)
    f = &fo;

  tau = 0;
  if (!DetectRecieverPos(t, *fr, rc))
    return false;
  for (;;)
    {
    t = GetTime();
    t -= tau / 86.4;
    if (!trj.Predict(t, *fr, *f))
      return false;
    tau1 = sqrt((rc.x - f->x) * (rc.x - f->x) +
                (rc.y - f->y) * (rc.y - f->y) +
                (rc.z - f->z) * (rc.z - f->z)) /
           Clight;
    if (fabs(tau - tau1) < TimePrec)
      return true;
    tau = tau1;
    }
   return false;
  }
///////////////////////////////////////////////////////////////////////////////
