///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//   ,  , 
///////////////////////////////////////////////////////////////////////////////
#include "AlphDelDCoords.h"
#include "Consts.h"
///////////////////////////////////////////////////////////////////////////////
//   
//-----------------------------------------------------------------------------
AlphDelDCoords::AlphDelDCoords()
  {
  Dist = Alpha = Delta = 0.0;
  } 
//-----------------------------------------------------------------------------
//    
//-----------------------------------------------------------------------------
void AlphDelDCoords::SetXYZ(const Vect3 &src)
  {
  Dist = src.Len();

  Delta = Dist > 0 ? asin(src.z / Dist) : 0.0; 
  Alpha = (src.x !=0 || src.y !=0 ) ? atan2(src.y, src.x) : 0.0 ; // <-- [-PI,+PI]
  if (Alpha < 0 ) 
    Alpha += Pi2;
  }
//-----------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------
void AlphDelDCoords::GetXYZ(Vect3 &dst) const
  {
  dst.z = Dist * sin(Delta);
  dst.x = Dist * cos(Delta) * cos(Alpha);
  dst.y = Dist * cos(Delta) * sin(Alpha);
  }
///////////////////////////////////////////////////////////////////////////////
