///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
// ,     
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_APRIORICONST_H
#define BNOTOOL_APRIORICONST_H
///////////////////////////////////////////////////////////////////////////////
#include "Matrix.h"
#include "ITraject.h"
#include "twll.h"
///////////////////////////////////////////////////////////////////////////////
//   
///////////////////////////////////////////////////////////////////////////////
enum AprioriConstType
  {
  acUnknown = 0,
    //   
  acBC = 1,
    //   . 
  acLPC = 2
  };
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
class IAprioriConst 
  {
  public: 
      // 
    IAprioriConst()
      { ACType = acUnknown;};
      // 
	  virtual ~IAprioriConst()
      {};

      //  
    virtual unsigned int GetSize() const = 0;
      //   
    virtual void GetDelVector(const DVector& u, DVector& del) const = 0;
      //    
    virtual void GetMatrix(const DVector& u, DMatrix &m) const = 0;
      //   
    virtual void GetWeightMatrix(DSymmMatrix& m) const = 0;
      //  
    virtual IAprioriConst* Clone() const = 0;
      
    virtual void Set(const DVector &u) = 0;

      //  
    AprioriConstType GetType() const
      { return ACType;};

    void SetType(AprioriConstType t)
      { ACType = t;};

  protected:
      // 
    AprioriConstType ACType;
  };
///////////////////////////////////////////////////////////////////////////////
//   ,    
///////////////////////////////////////////////////////////////////////////////
typedef class Twll_Entry_Class<IAprioriConst> IAprioriConstEntry;
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
class DAprioriConst : public IAprioriConstEntry 
  {
  public: 
      // 
    DAprioriConst() : IAprioriConstEntry()
      {};
      // 
	  virtual ~DAprioriConst()
      {};

      //  
    virtual unsigned int GetSize() const
      { return 1;};
      //   
    virtual void GetDelVector(const DVector& u, DVector &del) const;
      //    
    virtual void GetMatrix(const DVector& u, DMatrix &m) const;
      //   
    virtual void GetWeightMatrix(DSymmMatrix& m) const;
      //  
    virtual IAprioriConst* Clone() const;
      //     
    virtual void Set(const DVector &u);

      //  
    void SetParams(unsigned index, double v, double mse);

  protected:
      //     
    unsigned Index;
      //  
    double Value;
      //  
    double Mse;
  };
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
class IAprioriConstList: public Twll_List_Class <IAprioriConstEntry>
  {
  public:
      //   
    void Add(const IAprioriConst &a);
      //   
    void DeleteByType(AprioriConstType t);
      //     
    void Set(const DVector &u);
  };
///////////////////////////////////////////////////////////////////////////////
#endif
