///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//      B1900
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL__B1900FRAME_H
#define BNOTOOL__B1900FRAME_H
////////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "IFrames.h"
#include "SFramePars.h"
////////////////////////////////////////////////////////////////////////////////
  //   B1900
class B1900Frame : public IFrame
  {
  public:
      //     
    virtual const IFrameParameters & GetParameters() const
      { return Pars;};
      //   
    virtual void SetParameters(const IFrameParameters &p)
      { TAssert(p.GetFrameType() == csIdB1900);};
      //     ?
    virtual bool IsInertial() const
      { return true;};
      //     ?
    virtual bool IsGeocentric() const
      { return true;};

      //  ,        
      //    J2000    t0 ( 3- )
    virtual void Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const; 
      //  ,        
      //    J2000    t0 ( 6- )
    virtual void Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const;

  protected:
      //  
    B1900FrameParameters Pars;
  };
////////////////////////////////////////////////////////////////////////////////
#endif

