///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
#include "CloseAppr.h"
///////////////////////////////////////////////////////////////////////////////
//  ,     
///////////////////////////////////////////////////////////////////////////////
//   ,     
//-----------------------------------------------------------------------------
void CASpaceObjectList::GetHeightRange(double &hp, double &ha) const
  {
  if (first() == NULL && last() == NULL)
    return;

  ICASpaceObjectEntry *e = first();
  e->GetHeightRange(hp, ha);
  e = e->next();

  while (e != NULL)
    {
    double hmin, hmax;
    e->GetHeightRange(hmin, hmax);
    if (hmin < hp)
      hp = hmin;
    if (hmax > ha)
      ha = hmax;
    e = e->next();
    }

  return;
  }
//-----------------------------------------------------------------------------
//     
// (   ,     
//  )
//-----------------------------------------------------------------------------
void CASpaceObjectList::FilterByHeight(double hp, double ha)
  {
  ICASpaceObjectEntry *e = first(), *n;

  while (e != NULL)
    {
    n = e->next();
    double hmin, hmax;
    e->GetHeightRange(hmin, hmax);
    if (hmax < hp || hmin > ha)
      delete_node(e);
    e = n;
    }
  }
//-----------------------------------------------------------------------------
//     
// (   ,     
//    )
//-----------------------------------------------------------------------------
void CASpaceObjectList::FilterByTime(const TimeJD &ts, const TimeJD &te)
  {
  ICASpaceObjectEntry *e = first(), *n;

  while (e != NULL)
    {
    n = e->next();
    TimeJD tmin, tmax;
    e->GetTimeRange(tmin, tmax);
    if (tmax < ts || tmin > te)
      delete_node(e);
    e = n;
    }
  }
///////////////////////////////////////////////////////////////////////////////
