///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     
///////////////////////////////////////////////////////////////////////////////
#include "ComplexInit.h"
///////////////////////////////////////////////////////////////////////////////
static BNOAstroBase ABase;
///////////////////////////////////////////////////////////////////////////////
  // 
bool ComplexInit(const char *fname)
  {
  SetAstroBase(ABase); 

  if (fname != NULL)
    ABase.SetCfgFile(fname);

  return ABase.Init();
  }
//-----------------------------------------------------------------------------
  //        
bool ComplexInit(const TimeGD &s, const TimeGD &e, const char *fname)
  {
  SetAstroBase(ABase); 

  if (fname != NULL)
    ABase.SetCfgFile(fname);

  return ABase.Init(s, e);
  }
//-----------------------------------------------------------------------------
  //        
bool ComplexInit(const TimeJD &s, const TimeJD &e, const char *fname)
  {
  SetAstroBase(ABase); 

  if (fname != NULL)
    ABase.SetCfgFile(fname);

  return ABase.Init(s, e);
  }
//-----------------------------------------------------------------------------
  //   
void SetAtmosphereModel(TAtmosphereId mi)
  {
  ABase.SetAtmosphereModel(mi);
  }
//-----------------------------------------------------------------------------
  //     
bool SetGravityModel(TGravityModelId mi)
  {
  return ABase.SetEarthGravityModel(mi);
  }
//-----------------------------------------------------------------------------
  //     
bool LoadEphData(TPlanetId pl)
  {
  return ABase.LoadEphData(pl);
  }
//-----------------------------------------------------------------------------
  //      ( )
void UnLoadEphData(TPlanetId pl)
  {
  ABase.UnLoadEphData(pl);
  }
//-----------------------------------------------------------------------------
  //       
BNOAstroBase *GetBNOAstroBase()
  {
  return &ABase;
  }
///////////////////////////////////////////////////////////////////////////////
