///////////////////////////////////////////////////////////////////////////////
//   
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//   
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_CONST_H
#define BNOTOOL_CONST_H
///////////////////////////////////////////////////////////////////////////////
//    (  double)
///////////////////////////////////////////////////////////////////////////////
#include "epoch.h"
///////////////////////////////////////////////////////////////////////////////
//   
///////////////////////////////////////////////////////////////////////////////
#include "mathconst.h"
///////////////////////////////////////////////////////////////////////////////
#define EarthMeanRot (1.002737909350795*Pi2)  /*  .   (\) */
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
#define EarthMeanRot_Vallado (Pi2/0.99726968)  /*  .   (\c) */
#define MoonMeanRot_Vallado  (Pi2/27.32166)    /*  .    (\c) */
#define MercuryMeanRot_Vallado (Pi2/58.6462)   /*  .   (\c) */
#define VenusMeanRot_Vallado (Pi2/-243.01)     /*  .    (\c) */
#define MarsMeanRot_Vallado  (Pi2/1.02595675)  /*  .     (\c) */
#define JupiterMeanRot_Vallado  (Pi2/0.41354)  /*  .   (\c) */
#define SaturnMeanRot_Vallado  (Pi2/0.4375)    /*  .   (\c) */
#define UranusMeanRot_Vallado  (Pi2/-0.65)     /*  .     (\c) */
#define NeptuneMeanRot_Vallado (Pi2/0.768)     /*  .   (\c) */
#define PlutoMeanRot_Vallado   (Pi2/-6.3867)   /*  .   (\c) */
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#define MoonMeanRot_SSEJPL  (Pi2/27.321661)   /* average angle velocity of Moon    (rad\days) */
#define MercuryMeanRot_SSEJPL (Pi2/58.6462)   /* average angle velocity of Mercury (rad\days) */
#define VenusMeanRot_SSEJPL (Pi2/-243.0187)   /* average angle velocity of Venus   (rad\days) */
#define MarsMeanRot_SSEJPL  (Pi2/1.02595675)  /* average angle velocity of Mars    (rad\days) */
#define JupiterMeanRot_SSEJPL  (Pi2/0.41354)  /* average angle velocity of Jupiter (rad\days) */
#define SaturnMeanRot_SSEJPL  (Pi2/0.44401)   /* average angle velocity of Saturn  (rad\days) */
#define UranusMeanRot_SSEJPL  (Pi2/-0.71833)  /* average angle velocity of Uranus  (rad\days) */
#define NeptuneMeanRot_SSEJPL (Pi2/0.67125)   /* average angle velocity of Neptune (rad\days) */
#define PlutoMeanRot_SSEJPL   (Pi2/-6.38713)  /* average angle velocity of Pluto   (rad\days) */
#define SunMeanRot_SSEJPL   (Pi2/25.38)       /* average angle velocity of Pluto   (rad\days) */
///////////////////////////////////////////////////////////////////////////////
#define RLT 82.300587
///////////////////////////////////////////////////////////////////////////////
double const miuSun  = 0.132712439935e9;
double const miuMoon = 0.490279914e1;
///////////////////////////////////////////////////////////////////////////////
//    . 
///////////////////////////////////////////////////////////////////////////////
double const AstroUnit = 149597.870691;
///////////////////////////////////////////////////////////////////////////////
//   
///////////////////////////////////////////////////////////////////////////////
double const LaplaceAngle = 7.342 * deg2rad;
///////////////////////////////////////////////////////////////////////////////
#define Clight 299792.458  // km/sec speed of light, IERS Technical Note 21, table 2.2
               
#define REarthMid 6.3713
#endif
