///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     c   
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_DMINMNKTRAN_H
#define BNOTOOL_DMINMNKTRAN_H
///////////////////////////////////////////////////////////////////////////////
#include "IMinMnkTr.h"
///////////////////////////////////////////////////////////////////////////////
//       
//  
///////////////////////////////////////////////////////////////////////////////
class DMinMnkAnTune
{
public:
	virtual ~DMinMnkAnTune()
	{};
	//       
	virtual void ChangeIans(IMinTrFun &tf) = 0;
	//         
	virtual bool CheckRange(IMinTrFun &tf) 
	{ return true; };
};
///////////////////////////////////////////////////////////////
//      
//  
///////////////////////////////////////////////////////////////
class DMinMnkTrAn : public DMinMnk
{
public:
	// 
	DMinMnkTrAn(DMinMnkAnTune *f = NULL) : DMinMnk()
	{ Check = f; IanBuffer = NULL; KIan = 0; MaxFApr = 1.0;};
	// 
	virtual ~DMinMnkTrAn()
	{ if (IanBuffer != NULL) delete[] IanBuffer; };

	// 
	void Init(DMinMnkAnTune &f)
	{ Check = &f; };

	//  
	// u0 -  
	// f -  
	void Minimize(const DVector &u0, IMinTrFun &f);

	//    , 
	//   .   -  
	//     .   = 1.0
	double MaxFApr;

protected:
	//    
	DMinMnkAnTune *Check;
	//     
	unsigned short *IanBuffer;
	//     
	unsigned KIan;
	//     
	void SaveIans(IMeasurementPacket &p);
	//     
	//  
	bool HasCurIans(IMeasurementPacket &m);
	//      
	void RestoreIan(IMeasurementPacket &m);
};
///////////////////////////////////////////////////////////////////////////////
#endif
