///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//       
///////////////////////////////////////////////////////////////////////////////
#include "Matrix.h"
///////////////////////////////////////////////////////////////////////////////
//   
//-----------------------------------------------------------------------------
DTriagMem::DTriagMem()
  {
  Buffer = NULL;
  Dimension = 0;
  DimMem = 0;
  }
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
DTriagMem::~DTriagMem()
  {
  if (Buffer != NULL)
    delete Buffer;
  }
//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------
void DTriagMem::XChng(DTriagMem &m)
  {
  unsigned b;

  b = Dimension;
  Dimension = m.Dimension;
  m.Dimension = b;

  b = DimMem;
  DimMem = m.DimMem;
  m.DimMem = b;

  b = MemSize;
  MemSize = m.MemSize;
  m.MemSize = b;

  double *ptr;
  ptr = Buffer;
  Buffer = m.Buffer;
  m.Buffer = ptr;
  }
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
void DTriagMem::Init(unsigned dim)
  {
  if (ReqMemSize(dim) > MemSize || Buffer == NULL)
    {
    if (Buffer != NULL)
      delete Buffer;
    MemSize = ReqMemSize(dim);
    Buffer = new double[MemSize];
    }

  DimMem = Dimension = dim;
  }
//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------
void DTriagMem::ResetDimension(unsigned dim)
  {
  TAssert(dim <= DimMem);
  Dimension = dim;
  }
//-----------------------------------------------------------------------------
//      
//-----------------------------------------------------------------------------
void DTriagMem::Init(double value)
  {
  TAssert(Buffer != NULL);

  register unsigned i, j;

  for (i = 0; i < Dimension; i++)
    for (j = i; j < Dimension; j++)
      Buffer[Index(i, j)] = value;
  }
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
void DTriagMem::Mult(double mltp)
  {
  TAssert(Buffer != NULL);

  register unsigned i, j;

  for (i = 0; i < Dimension; i++)
    for (j = i; j < Dimension; j++)
      Buffer[Index(i, j)] *= mltp;
  }
///////////////////////////////////////////////////////////////////////////////
