///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//      
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_DIGPREDICT_H
#define BNOTOOL_DIGPREDICT_H
///////////////////////////////////////////////////////////////////////////////
#include "IPredict.h"
#include "IODE.h"
#include "ODESystem.h"
#include "ODEStpnSolver.h"
#include "KOConst.h"
///////////////////////////////////////////////////////////////////////////////
//     ,    
///////////////////////////////////////////////////////////////////////////////
class DigPredict : public IPredict
{
public:
	DigPredict();
	virtual ~DigPredict() {};

	//  

	//   
	void SetIntegrator(IODESolver *slv);
	//    
	void SetAdapter(AccAdapter *acc)
	{ Adapter = acc;};
	//    
	void SetKOProp(IKOProp *prop);
	//  
	virtual bool Run(const TimeJD &t);
	//   
	virtual void GetDestPoint(PhasePoint6D &dest);

	//     
	void SetInitPoint(const PhasePoint6D &src);
	// ""    
	virtual void ReRun();

	//   
	MotionMode MMode;

protected:
	//  
	ODEPhaseSystem System;
	// 
	IODESolver *Integrator;
	//   
	AccAdapter *Adapter;
	//   
	IKOProp *KOProp;
	//    
	bool FlagInit; 
	//  ,    
	TimeJD T0;   
};
///////////////////////////////////////////////////////////////////////////////
//   :
// -  ..
// -  ,     
// -    .   .  
///////////////////////////////////////////////////////////////////////////////
class DigStPredict : public DigPredict
{
public:
	DigStPredict();
	DigStPredict(double eps, double stepinit, double stepmin, bool precItrf);

	//   
	void SetKOParams(double kb, double kappa);
	//     
	void SetAccuracy(double eps, double stepinit, double stepmin, bool precItrf);

	// 
	ODEStpnSolver SIntegrator;
	//  
	KOConst KOModel;

protected:
	// 
	AccAdapter SAdapter;

private:
	//    
	void SetIntegrator(IODESolver *slv);
	//     
	void SetAdapter(AccAdapter *acc);
	//     
	void SetKOProp(IKOProp *prop);

	// 
	double m_eps;
	//  
	double m_stepinit;
	//  
	double m_stepmin;
};

#endif
