///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//        
//   
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_DIGPREDICTVAR_H
#define BNOTOOL_DIGPREDICTVAR_H
///////////////////////////////////////////////////////////////////////////////
#include "IPredict.h"
#include "IODE.h"
#include "ODESystem.h"
#include "ODEStpnSolver.h"
#include "KOConstVar.h"
///////////////////////////////////////////////////////////////////////////////
//        , 
//    
///////////////////////////////////////////////////////////////////////////////
class DigPredictVar : public IPredictVar
{
public:
	//   
	DigPredictVar();
	// 
	virtual ~DigPredictVar() {};

	//  

	//   
	void SetIntegrator(IODESolver *slv);
	//    
	void SetAdapter(AccAdapter *acc)
	{ Adapter = acc;};

	//    
	void SetKOProp(IKOPropVar *prop);

	//  
	virtual bool Run(const TimeJD &t);
	//   
	virtual void GetDestPoint(PhasePoint6D &dest);
	//    
	virtual void GetDestMatrix(DMatrix &m);

	//     
	void SetInitPoint(const PhasePoint6D &src, const DMatrix *vars = NULL);
	// ""    
	virtual void ReRun();

	//   
	MotionMode MMode;

protected:
	//  
	ODEVarSystem System;
	// 
	IODESolver *Integrator;
	//   
	AccAdapter *Adapter;
	//   
	IKOPropVar *KOProp;
	//    
	bool FlagInit; 
	//  ,    
	TimeJD T0; 
};

///////////////////////////////////////////////////////////////////////////////
//      :
// -  ..
// -  ,     
// -    .   .  
///////////////////////////////////////////////////////////////////////////////
class DigStPredictVar : public DigPredictVar
{
public:
	DigStPredictVar();
	DigStPredictVar(double eps, double stepmin, double stepinit, bool precItrf);

	//   
	void SetKOParams(double kb, double kappa, bool iskbvar = false, bool iskappavar = false);
	//     
	void SetAccuracy(double eps, double stepinit, double stepmin, bool precItrf);

	// 
	ODEStpnSolver SIntegrator;

protected:
	// 
	AccAdapter SAdapter;
	//  
	KOConstVar KOModel;

private:
	//    
	void SetIntegrator(IODESolver *slv);
	//     
	void SetAdapter(AccAdapter *acc);
	//     
	void SetKOProp(IKOPropVar *prop);

	// 
	double m_eps;
	//  
	double m_stepinit;
	//  
	double m_stepmin;
};
///////////////////////////////////////////////////////////////////////////////
#endif
