///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     ECI   
////////////////////////////////////////////////////////////////////////////////
#include "ECIFrame.h"
#include "IAstroBase.h"
////////////////////////////////////////////////////////////////////////////////
  //   
void ECIFrame::SetParameters(const IFrameParameters &p)
  {
  TAssert(p.GetFrameType() == csIdECI);
  const ECIFrameParameters &pm = (const ECIFrameParameters &)p;
  Pars = pm;
  }
//------------------------------------------------------------------------------
  //  ,        
  //    J2000    t0 ( 3- )
void ECIFrame::Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const
  {
  TAssert(Pars.IsInit());

  result.Init();

  GetAstroBase()->MtxPrecession(Pars.GetTime(), TimeJD(0, doubleJ2000), 
    result.Rotation);
  return;
  }
//------------------------------------------------------------------------------
  //  ,        
  //    J2000    t0 ( 6- )
void ECIFrame::Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const
  {
  TAssert(Pars.IsInit());
  result.Init();
  Get3DJ2000Converter(t0, result.Converter3D);
  }
////////////////////////////////////////////////////////////////////////////////

