///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     ECI   
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL__ECIFRAME_H
#define BNOTOOL__ECIFRAME_H
////////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "IFrames.h"
#include "SFramePars.h"
////////////////////////////////////////////////////////////////////////////////
class ECIFrame : public IFrame
  {
  public:
      //   
    ECIFrame()
      {};
      //     
    ECIFrame(const TimeJD &t)
      { Init(t);};

      //     
    ECIFrame & Init(const TimeJD &t)
      { Pars.TFrameParameters::Init(t); return *this;};

      //     
    virtual const IFrameParameters & GetParameters() const
      { return Pars;};
      //   
    virtual void SetParameters(const IFrameParameters &p);
      //     ?
    virtual bool IsInertial() const
      { return true;};
      //     ?
    virtual bool IsGeocentric() const
      { return true;};

      //  ,        
      //    J2000    t0 ( 3- )
    virtual void Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const; 
      //  ,        
      //    J2000    t0 ( 6- )
    virtual void Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const;

    const TimeJD &GetFixTime() const
      { return Pars.GetTime();};

  protected:
      //  
    ECIFrameParameters Pars;
  };
////////////////////////////////////////////////////////////////////////////////
#endif

