///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//      
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL__FGREENWICHFRAME_H
#define BNOTOOL__FGREENWICHFRAME_H
////////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "IFrames.h"
#include "SFramePars.h"
////////////////////////////////////////////////////////////////////////////////
class FGreenwichFrame : public IFrame
  {
  public:
      //   
    FGreenwichFrame()
      {};
      //     
    FGreenwichFrame(const TimeJD &t)
      { Init(t);};

      //     
    FGreenwichFrame & Init(const TimeJD &t)
      { Pars.TFrameParameters::Init(t); return *this;};

      //     
    virtual const IFrameParameters & GetParameters() const
      { return Pars;};
      //   
    virtual void SetParameters(const IFrameParameters &p);
      //     ?
    virtual bool IsInertial() const
      { return true;};
      //     ?
    virtual bool IsGeocentric() const
      { return true;};

      //  ,        
      //    J2000    t0 ( 3- )
    virtual void Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const; 
      //  ,        
      //    J2000    t0 ( 6- )
    virtual void Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const;
      //  ,        
      //    rf    t0 ( 3- )
    virtual void Get3DConverter(const IFrame &rf, const TimeJD &t0, 
                                FrameConverter3D &result) const;
      //  ,        
      //    rf    t0 ( 6- )
    virtual void Get6DConverter(const IFrame &rf, const TimeJD &t0, 
                                FrameConverter6D &result) const;

    const TimeJD &GetFixTime() const
      { return Pars.GetTime();};

  protected:
      //  
    FGreenwichFrameParameters Pars;
  };
////////////////////////////////////////////////////////////////////////////////
#endif

