///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//       
//    
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL__FRAMECONVERTER_H
#define BNOTOOL__FRAMECONVERTER_H
////////////////////////////////////////////////////////////////////////////////
#include "DVectors.h"
////////////////////////////////////////////////////////////////////////////////
class FrameConverter3D
  {
  public:
      //   .   . 
    FrameConverter3D()
      { Init();};
      // ,      
    FrameConverter3D(const TransMtx &m, const Vect3 &r)
      { Init(m, r); };

      //  -   
    FrameConverter3D & Init()
      { Rotation.Init1(); Shift = 0; return *this;};
      // ,      
    FrameConverter3D & Init(const TransMtx &m, const Vect3 &r)
      { Rotation = m; Shift = r; return *this; };

      //       
	    //       .
    void Convert(const Vect3 &source, Vect3 &target) const;

      //    result  
		void Invert(FrameConverter3D &result) const;

      //     
    FrameConverter3D & Invert();

      //   result   .
	    //     -  
	    //    -  c.
    void Multiply(const FrameConverter3D &c, FrameConverter3D & result) const;
      //         
    FrameConverter3D & Multiply(const FrameConverter3D & c);

      //   

      //  
    TransMtx Rotation;
      //  .     
	    //     .
    Vect3 Shift;
  };
////////////////////////////////////////////////////////////////////////////////
class FrameConverter6D
  {
  public:
      //   .   . 
    FrameConverter6D()
      { Init();};
      //     
    FrameConverter6D(const FrameConverter3D &c, const TransMtx &m, 
                    const Vect3 &v)
      { Init(c, m, v);}; 
    FrameConverter6D(const TransMtx &mc, const TransMtx &mv,
                     const Vect6 &rv)
      { Init(mc, mv, rv); }; 

      //  -   
    FrameConverter6D & Init()
      { Converter3D.Init(); VShift = 0; VRotation = 0; return *this;};
      //     
    FrameConverter6D & Init(const FrameConverter3D &c, const TransMtx &m, 
                     const Vect3 &v)
      { Converter3D = c; VRotation = m; VShift = v; return *this;};
      //        
    FrameConverter6D & Init(const TransMtx &mc, const TransMtx &mv,
                            const Vect6 &rv);

      //       
	    //       .
    void Convert(const Vect6 &source, Vect6 &target) const;

      //    result  
    void Invert(FrameConverter6D & result) const;
      //     
    FrameConverter6D & Invert();

      //   result   .
	    //     -  
	    //    -  c.
    void Multiply(const FrameConverter6D &c, FrameConverter6D & result) const;
      //         
    FrameConverter6D & Multiply(const FrameConverter6D & c);


      //  
    FrameConverter3D Converter3D;
      //  
    TransMtx VRotation;
      //  .     
	    //     .
    Vect3 VShift;
  };
////////////////////////////////////////////////////////////////////////////////
#endif
