///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     -2004.
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_G2004ATMCOEF_H
#define BNOTOOL_G2004ATMCOEF_H
///////////////////////////////////////////////////////////////////////////////
// ,    
//    -2004.
///////////////////////////////////////////////////////////////////////////////
class G2004AtmCoef
{
  private:
    // .
    G2004AtmCoef();
  public:
    //      F0  -2004.
    enum { NumF0Levels = 7 };
    //     F0  -2004 :
    // 75(0), 100(1), 125(2), 150(3), 175(4), 200(5), 250(6).
    //      
    //   .
    static const double F0Level[ NumF0Levels ];
    //     
    //   .
    // f81 - c   .
    //   :   
    //    .
    static int getF0Index(double f81);
    // C   
    //      120 .
    struct LowAtmCoefStruct
    {
      double h;
      double a0;
      double k1;
      double k2;
    };
    //     
    //     120 .
    // h -      [].
    //   :    .
    static const LowAtmCoefStruct& getLowAtmCoef(double h);
    //   : a0, a1, a2, a3, a4, a5, a6.
    // h   -      [].
    // ind -    
    //         (  ).
    //   :    .
    static const double* getCoef_a(double h, int ind);
    //   : b0, b1, b2, b3, b4.
    // h   -      [].
    // ind -    
    //         (  ).
    //   :    .
    static const double* getCoef_b(double h, int ind);
    //   : c0, c1, c2, c3, c4, n0, n1, n2, phi1.
    // h   -      [].
    // ind -    
    //         (  ).
    //   :    .
    static const double* getCoef_c(double h, int ind);
    //   : d0, d1, d2, d3, d4.
    // h   -      [].
    // ind -    
    //         (  ).
    //   :    .
    static const double* getCoef_d(double h, int ind);
    //   : e0, e1, e2, e3, e4, e5, e6, e7, e8, et5, et6, et7, et8.
    // h   -      [].
    // ind -    
    //         (  ).
    //   :    .
    static const double* getCoef_e(double h, int ind);
    //   : l0, l1, l2, l3, l4.
    // h   -      [].
    // ind -    
    //         (  ).
    //   :    .
    static const double* getCoef_l(double h, int ind);
    //    
    //      (9 ).
    //   :    .
    static const double* getCoef_A();
};
///////////////////////////////////////////////////////////////////////////////
#endif // BNOTOOL_G2004ATMCOEF_H
///////////////////////////////////////////////////////////////////////////////
