///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//   
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_GEOCOORDS_H
#define BNOTOOL_GEOCOORDS_H
///////////////////////////////////////////////////////////////////////////////
#include "ICoords3D.h"
#include "IModel.h"

///////////////////////////////////////////////////////////////////////////////
class GeoCoords : public ICoords3D
{
public:
	double H;    // 
	double Phi;  //  []
	double Lam;  //  []

	//   
	GeoCoords();
	GeoCoords(double Re, double Alpha);
	GeoCoords(const IGravityModel& model);

	//         
	void SetParams(double re, double alpha)
	{ Re = re; Alpha = alpha; };
	//   
	double GetRe() const
	{ return Re;};
	double GetAlpha() const
	{ return Alpha;};

	//    
	virtual void SetXYZ(const Vect3 &src);
	//   
	virtual void GetXYZ(Vect3 &dst) const;

	//   
	bool operator==(const GeoCoords &p) const
	{ return (H == p.H) && (Phi == p.Phi) && (Lam == p.Lam) && (Re == p.Re) && (Alpha == p.Alpha);};

protected:
	double Re;    //  
	double Alpha; // . 

	//       
	double SDistance() const;
};
///////////////////////////////////////////////////////////////////////////////
class GeoCoordsPrec : public GeoCoords
{
public:
	GeoCoordsPrec() : GeoCoords(){};
	GeoCoordsPrec(double EarthRadius, double EarthOblatness) : GeoCoords(EarthRadius, EarthOblatness){};
	//    
	virtual void SetXYZ(const Vect3 &src);
};
///////////////////////////////////////////////////////////////////////////////
#endif
