///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     
//  
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_GEOSOLARFLUX_H
#define BNOTOOL_GEOSOLARFLUX_H
///////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "TM.h"
#include "IModel.h"
#include <string>
#include <vector>
///////////////////////////////////////////////////////////////////////////////
//       
///////////////////////////////////////////////////////////////////////////////
class TTableGeoSolarFlux : public ITableGeoSolarFlux
  {
  public:
      //   
    TTableGeoSolarFlux();
      // 
    virtual ~TTableGeoSolarFlux();

      //     
    virtual const TGeoSolarFlux *Get_F107(const TimeJD &tm) const;
      //      
    virtual const double *Get_Kp3hour(const TimeJD &tm) const;
      //    
    virtual double Get_Kp3hourMod(const TimeJD &tm) const;

      //   
    bool Init(const char *fname);
      //        
	void Save(const TimeJD &ts, const TimeJD &te,  std::vector<std::string>& res);
      //    
    void SetConstValue(double f135, double f90, double f81, double f135w, double f81w, 
      double f01, double kp, int ap);
      //       
    void SetConstUsing(bool I)
      { constUsing = I;};

  private:
    TimeJD jdbeg;
    TimeJD k3first, k3last;
    TimeJD Ffirst, Flast;
    TimeJD Kfirst, Klast;
    TimeJD F107level;
    TGeoSolarFlux *table;
    TGeoSolarFlux consts;
    unsigned long int len;
    bool constUsing;

    void GetIndex(const TimeJD &t, unsigned &index, double &daytime) const;
  };
///////////////////////////////////////////////////////////////////////////////
#endif

