///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//      
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL__GREENWICHFRAME_H
#define BNOTOOL__GREENWICHFRAME_H
////////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "IFrames.h"
#include "SFramePars.h"
////////////////////////////////////////////////////////////////////////////////
class GreenwichFrame : public IFrame
  {
  public:
      //     
    virtual const IFrameParameters & GetParameters() const
      { return Pars;};
      //   
    virtual void SetParameters(const IFrameParameters &p)
      { TAssert(p.GetFrameType() == csIdGCS);};
      //     ?
    virtual bool IsInertial() const
      { return false;};
      //     ?
    virtual bool IsGeocentric() const
      { return true;};

      //  ,        
      //    J2000    t0 ( 3- )
    virtual void Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const; 
      //  ,        
      //    J2000    t0 ( 6- )
    virtual void Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const;
      //  ,        
      //    rf    t0 ( 3- )
    virtual void Get3DConverter(const IFrame &rf, const TimeJD &t0, 
                                FrameConverter3D &result) const;
      //  ,        
      //    rf    t0 ( 6- )
    virtual void Get6DConverter(const IFrame &rf, const TimeJD &t0, 
                                FrameConverter6D &result) const;

  protected:
      //  
    GreenwichFrameParameters Pars;
  };
////////////////////////////////////////////////////////////////////////////////
#endif

