///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//      
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_IFRAMES_H
#define BNOTOOL_IFRAMES_H
////////////////////////////////////////////////////////////////////////////////
#include "Ids.h"
#include "FrameConverter.h"
#include "TM.h"
////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
class IFrameParameters
  {
  public:
      // 
    virtual ~IFrameParameters()
      {};
      //    
    virtual TCoordSysId GetFrameType() const = 0;
      //    
    virtual bool IsEqual(const IFrameParameters &c) const = 0;
  };
////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
class IFrame
  {
  public:
      // 
    virtual ~IFrame()
      {};

      //     
    virtual const IFrameParameters & GetParameters() const = 0;
      //   
    virtual void SetParameters(const IFrameParameters &p) = 0;
      //     ?
    virtual bool IsInertial() const = 0;
      //     ?
    virtual bool IsGeocentric() const = 0;

      //    
    TCoordSysId GetType() const
      { return GetParameters().GetFrameType(); };
      //    
    bool IsEqual(const IFrame &rf) const
      { return GetParameters().IsEqual(rf.GetParameters());};

      //  ,        
      //    J2000    t0 ( 3- )
    virtual void Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const = 0; 
      //  ,        
      //    J2000    t0 ( 6- )
    virtual void Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const = 0; 

      //  ,        
      //    rf    t0 ( 3- )
    virtual void Get3DConverter(const IFrame &rf, const TimeJD &t0, 
                                FrameConverter3D &result) const;
      //  ,        
      //    rf    t0 ( 6- )
    virtual void Get6DConverter(const IFrame &rf, const TimeJD &t0, FrameConverter6D &result) const;
  };
////////////////////////////////////////////////////////////////////////////////
IFrame * CreateIFrame(const IFrameParameters &p);
////////////////////////////////////////////////////////////////////////////////
#endif
