///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_IKOPROP_H
#define BNOTOOL_IKOPROP_H
///////////////////////////////////////////////////////////////////////////////
#include "AccAdapter.h"
#include "Matrix.h"
///////////////////////////////////////////////////////////////////////////////
//       
///////////////////////////////////////////////////////////////////////////////
class IKOProp
  {
  public:
      //   
    IKOProp()
      { MMode = NULL;};
      // 
    IKOProp(MotionMode &m)
      { MMode = &m;};
      // 
    virtual ~IKOProp()
      {}; 
      //   
    void Init(const MotionMode &m)
      { MMode = &m;};
      //      J2000
    virtual void GetAcc(const AccAdapter &p, Vect3 &acc) const = 0;
 
  protected:
    const MotionMode *MMode;
  };
///////////////////////////////////////////////////////////////////////////////
//          
//   
///////////////////////////////////////////////////////////////////////////////
class IKOPropVar : public IKOProp
  {
  public:
      //    
    virtual int GetNVars() const = 0;
      //        , 
      //   KO
    virtual void GetRPVars(const AccAdapter &p, TransMtx &dfdr, TransMtx &dfdv,
                           DMatrix &dfdc) const = 0;
  };
///////////////////////////////////////////////////////////////////////////////
#endif

