///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
#include "IMeasurement.h"
///////////////////////////////////////////////////////////////////////////////
//    
//        
///////////////////////////////////////////////////////////////////////////////
// 
//-----------------------------------------------------------------------------
IMeasurement::IMeasurement() :
    Type(mtUnknown),
    MTime(),
	m_rearranged(true),
	m_droppable(true),
	counter(0)
  {
  }
//-----------------------------------------------------------------------------
//     p   ,
//     
//-----------------------------------------------------------------------------
void IMeasurement::GetWeightMatrix(DSymmMatrix &p) const
  {
  p.Init(GetSize());
  unsigned i, j;

  DVector pm;
  GetMSEVector(pm);

  for (i = 0; i < GetSize(); i++)
    p(i, i) = 1.0 / (pm[i] * pm[i]);

  for (i = 0; i < GetSize() - 1; i++)
    {
    for (j = i + 1; j < GetSize(); j++)
      p(i, j) =  0.0;
    }
  }
///////////////////////////////////////////////////////////////////////////////
// ,        
///////////////////////////////////////////////////////////////////////////////
// 
 //-----------------------------------------------------------------------------
AMeasurement::AMeasurement() : IMeasurement(),
   // WrkFrame(0),
    FrameConverter()
  {
  }
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
AMeasurement::~AMeasurement()
{
/*	if (WrkFrame != NULL){
		delete WrkFrame;
		WrkFrame = 0;
	}*/
}
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
void AMeasurement::SetWrkFrame(const IFrame &fr) const
{
	//  TAssert(GetSrcFrame() != NULL);

	// if (WrkFrame != 0 && WrkFrame->IsEqual(fr))
	// return;

	//  if (WrkFrame != NULL)
	//  delete WrkFrame;
	///////////////////////////////////////////////////////////////////////////////
	IFrame* WrkFrame = CreateIFrame(fr.GetParameters());
	WrkFrame->Get6DConverter(*GetSrcFrame(), GetTime(), FrameConverter);
}



