///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//   
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_IMEASUREMENTPACKET_H
#define BNOTOOL_IMEASUREMENTPACKET_H
///////////////////////////////////////////////////////////////////////////////
#include "IMeasurement.h"
#include "IMeasurementFilter.h"
///////////////////////////////////////////////////////////////////////////////
class IMeasurementPacket
  {
  public:
      //      
    virtual ~IMeasurementPacket() 
      {};
      //      
    virtual unsigned GetSize() const = 0;
      //   true,    (    )
      //   false   
    virtual bool IsEmpty() const = 0;
      //       
    virtual unsigned GetActiveSize() const = 0;
      //   true,        
      //   false   
    virtual bool IsActive() const = 0;
      //      
    virtual void SetFirst() = 0;
      //      
    virtual void SetLast() = 0;
      //       .
      //    ,     
    virtual void SetFirstActive() = 0;
      //       .
      //    ,     
    virtual void SetLastActive() = 0;
      //      ,      
      //   t. 
      //    ,     
    virtual void SetByTime(const TimeJD &t) = 0;
      //       ,   
      //     t.
      //    ,     
    virtual void SetByTimeActive(const TimeJD &t) = 0;
      //          m.
      //      ,    .
    virtual void SetCurrent(const IMeasurement &m) = 0;
      //  t           id.
      //      ,    .
    virtual void SetCurrent(TMeasId id) = 0;
      //       .
      //     ,   NULL.
    virtual const IMeasurement* GetCurrent() const = 0;
	virtual IMeasurement* GetCurrent() = 0;
      //    ,      
      //   .
      //      ,
      //        .
    virtual void GoNext() = 0;
      //    ,     
      //   .
      //      ,
      //        .
    virtual void GoPrev() = 0;
      //      ,     
      //    .
      //    ,        .
    virtual void GoNextActive() = 0;
      //      ,     
      //    .
      //    ,        .
    virtual void GoPrevActive() = 0;
      //      ,    id.
      //      ,    NULL.
      //      .
    virtual const IMeasurement* Find(TMeasId id) const = 0;
      //  t true,      (..   )
    virtual bool IsActive(const IMeasurement &m) const = 0;
      //  t true,     id   (..   )
    virtual bool IsActive(TMeasId id) const = 0;
      //        m  .
      //    true,     , ,
      //    .
    virtual bool GetManualFlag(const IMeasurement &m) const = 0;
      //        
      //  id  .
      //    true,     , ,
      //    .
    virtual bool GetManualFlag(TMeasId id) const = 0;
      //    f     m  .
      //  f  true,    , ,    .
    virtual void SetManualFlag(const IMeasurement &m, bool f) = 0;
      //    f     
      //  id  .
      //  f  true,    , ,    .
    virtual void SetManualFlag(TMeasId id, bool f) = 0;
      //        m  .
      //    true,     , ,
      //    .
    virtual bool GetAutoFlag(const IMeasurement &m) const = 0;
      //        
      //  id  .
      //    true,     , ,
      //    .
    virtual bool GetAutoFlag(TMeasId id) const = 0;
      //           
    virtual void ClearAutoFlags() = 0;
      //   ,      
    virtual void SetFilter(const IMeasurementFilter *f) = 0;
      //     ,   
      //   
    virtual const IMeasurementFilter *GetFilter() = 0;
      //           meas
    virtual void FilterMeasurement(const IMeasurement &m, const DVector &del) = 0;
      //   true,      
      //    kmin
      //      
    virtual bool IsEnough(unsigned kmin) = 0;
	
	virtual void SetDeleteFlag(const IMeasurement &m, bool f) = 0;
	virtual bool GetDeleteFlag(TMeasId id) const = 0;
	virtual bool GetDeleteFlag(const IMeasurement &m) const = 0;

  };
///////////////////////////////////////////////////////////////////////////////
#endif
