///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//  ,  ,     
//        
///////////////////////////////////////////////////////////////////////////////
#ifndef IMINMNK_TRAJECT_H
#define IMINMNK_TRAJECT_H
///////////////////////////////////////////////////////////////////////////////
#include "IMinMnk.h"
#include "ITraject.h"
#include "IMeasurementPacket.h"
#include "AprioriConst.h"
///////////////////////////////////////////////////////////////////////////////
class IMinTrFun : public IMinFunct, public ITrajectVar
  {
  public:
      // 
    IMinTrFun();
      // 
    virtual ~IMinTrFun();

      //    
    virtual unsigned Size() const = 0;
      //    ,  
      //   
      //   false,    
      //     
    virtual bool Fun(const DVector &u, double &f, DVector *df = NULL,
                     DSymmMatrix *fm = NULL);

      //  
    void SetPacket(IMeasurementPacket *p);
      //     
    IMeasurementPacket *GetPacket() const
      { return MPacket;};

      //    
    void SetPrintFlag(bool f)
      { PrintFlag = f; };
      //      
    void SetPrintMatrix(bool f)
      { PrintMatrix = f; };

      //        
    void SetDigMtx(bool f)
      { UseDigMtx = f;};
      //        
    bool GetDigMtx() const
      { return UseDigMtx;};

      //   
    const DVector &GetDel(unsigned k) const
      { return Del[k];};

      //    
    bool HasApr() const
      { return !ACList.isempty();};
      //     
    double GetFa() const
      { return Fa;};
      //      
    void SetApr(const DVector &u)
      { ACList.Set(u);};
      //   
    void AddApr(const IAprioriConstEntry &a)
      { ACList.Add(*a.Clone());};
      //   
    void ClearApr()
      { ACList.clear();};

  protected:
      //        
    bool UseDigMtx;
      // ,       
    virtual void GetEps(DVector &eps) const = 0;
      //   
    virtual bool IsValid(const DVector &u) const = 0;
      //   
    double Fa;  
      //   ,   
    IMeasurementPacket *MPacket;
      //   
    IAprioriConstList ACList;
      //  
    DVector *Del;
      //   
    bool PrintFlag;
      //     
    bool PrintMatrix;

      //        
      //  
    bool CreatePDM(const DVector &u, DMatrix *matr);
      //    
    void PrintMeas(int k, const IMeasurement &meas, const DVector &d, const DSymmMatrix &w);
      //    . 
    void PrintApr(int k, const IAprioriConst &apr, const DVector &d, const DSymmMatrix &w);
      //    
    void PrintMatr(const DMatrix &m) const;
  };
///////////////////////////////////////////////////////////////////////////////
#endif
