///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//       
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_IODE_H
#define BNOTOOL_IODE_H
///////////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
///////////////////////////////////////////////////////////////////////////////
//       
///////////////////////////////////////////////////////////////////////////////
class IODESystem
  {
  public:
      //   
    virtual ~IODESystem() 
      {} ;
      //   
    virtual int GetDimension() const = 0;
      //   
      //   false,    ,
      //     
    virtual bool GetRP(double t, const double *ph, double *f) = 0;
  };
///////////////////////////////////////////////////////////////////////////////
//    ,    . 
// 
///////////////////////////////////////////////////////////////////////////////
class IODESolver
  {
  public:
      //   
    IODESolver();
      // 
    virtual ~IODESolver();

      //   
    virtual void SetSystem(IODESystem* odesystem);
      //   
    virtual const IODESystem* GetSystem(IODESystem* odesystem)
      { return System; };
      //   
    virtual void SetInitial(double x, const double* y);
      //       
    virtual bool Run(double x) = 0;
      //   
    virtual const double* GetSolution() const
      { return Yk + 1;};
      //   
    virtual double GetX() const
      { return Yk[0];};
      
  protected:
      // ,    
    IODESystem *System;
      //   ( + . )
    double *Y0;
      //   ( + . )
    double *Yk; 
      //    
    bool IsInit;       
  };
///////////////////////////////////////////////////////////////////////////////
#endif

