///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//      J2000
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL__J2000FRAME_H
#define BNOTOOL__J2000FRAME_H
////////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "IFrames.h"
#include "SFramePars.h"
////////////////////////////////////////////////////////////////////////////////
class J2000Frame : public IFrame
  {
  public:
      //     
    virtual const IFrameParameters & GetParameters() const
      { return Pars;};
      //   
    virtual void SetParameters(const IFrameParameters &p)
      { TAssert(p.GetFrameType() == csIdJ2000);};
      //     ?
    virtual bool IsInertial() const
      { return true;};
      //     ?
    virtual bool IsGeocentric() const
      { return true;};

      //  ,        
      //    J2000    t0 ( 3- )
    virtual void Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const 
      { result.Init(); };
      //  ,        
      //    J2000    t0 ( 6- )
    virtual void Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const
      { result.Init();};

  protected:
      //  
    J2000FrameParameters Pars;
  };
////////////////////////////////////////////////////////////////////////////////
#endif

