///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_KEPLER_H
#define BNOTOOL_KEPLER_H
///////////////////////////////////////////////////////////////////////////////
#include "ICoords6D.h"
#include "IModel.h"
///////////////////////////////////////////////////////////////////////////////
class Kepler : public ICoords6D
  {
  public:
    double A;      //   
    double Ex;     // e * cos(omp)
    double Ey;     // e * sin(omp)
    double CosI;   //  
    double Omega;  //   
    double U;      //  

      //   
    Kepler();

	TimeJD GetTimeFromAN(TimeJD base) const;

      //   
    void SetParam(double mu)
      { Mu = mu;};
      //   
    double GetMu() const
      { return Mu;};

      //      
    virtual void SetXYZ(const Vect6 &src);
      //     
    virtual bool GetXYZ(Vect6 &dst) const;

      //  
      //  
    double GetPeriod() const;
      //  
    double GetRP() const;
      //  
    double GetRA() const;
      //    
    double GetHP(const TGeometryModel *geom = NULL) const;   
      //    
    double GetHA(const TGeometryModel *geom = NULL) const;   
      //  
    double GetEcc() const;
      //  
    double GetArgP() const;
      //    
    double GetLaplaceInc() const;
      //      
    double GetLaplaceLAN() const;
      //    .    
    double GetTimeFromAN() const;
      //  
    double GetTrueAnomaly() const;
      //        ( EL23)
    double GetTimeP() const;
	double GetSPeriod(int NF) const;
  protected:
    double Mu;     //     
  };
///////////////////////////////////////////////////////////////////////////////
#endif
