///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_LAGRANGE_H
#define BNOTOOL_LAGRANGE_H
///////////////////////////////////////////////////////////////////////////////
#include "ICoords6D.h"
#include "IModel.h"
#include "Matrix.h"
///////////////////////////////////////////////////////////////////////////////
class Lagrange : public ICoords6D
  {
  public:
    double Lambda;       
    double L;
    double P;
    double Q;
    double H;
    double K;

      //   
    Lagrange();

      //   
    void SetParam(double mu)
      { Mu = mu;};
      //   
    double GetMu() const
      { return Mu;};

      //      
    virtual void SetXYZ(const Vect6 &src);
      //     
    virtual bool GetXYZ(Vect6 &dst) const;

      //  
      //  
    double GetPeriod() const;
      //  
    double GetRP() const;
      //  
    double GetEcc() const;

      //   
    void Save(FILE *f) const;
      //   
    void Load(FILE *f);

  protected:
    double Mu;     //     
    double Prec;   //     
    int NMax;      // .     

      //    
    bool SolveKeplerEq(double *oke) const;
  };
///////////////////////////////////////////////////////////////////////////////
//       
//   
///////////////////////////////////////////////////////////////////////////////
bool DXYZDLagrange(const Lagrange &lagr, DSqrMatrix &d);
///////////////////////////////////////////////////////////////////////////////
#endif
