///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     ()  J2000
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL__LOCALJ2000FRAME_H
#define BNOTOOL__LOCALJ2000FRAME_H
////////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "IFrames.h"
#include "SFramePars.h"
////////////////////////////////////////////////////////////////////////////////
class LocalJ2000Frame : public IFrame
  {
  public:
      //     
    virtual const IFrameParameters & GetParameters() const
      { return Pars;};
      //   
    virtual void SetParameters(const IFrameParameters &p);
      //     ?
    virtual bool IsInertial() const
      { return false;};
      //     ?
    virtual bool IsGeocentric() const
      { return false;};

      //  ,        
      //    J2000    t0 ( 3- )
    virtual void Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const; 
      //  ,        
      //    J2000    t0 ( 6- )
    virtual void Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const;

      //        
    void Init(const GeoCoordsPrec &p)
      { Pars.Init(p);};

  protected:
      //  
    LocalJ2000FrameParameters Pars;
  };
////////////////////////////////////////////////////////////////////////////////
#endif
