///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//      
///////////////////////////////////////////////////////////////////////////////
#include "MMode.h"
///////////////////////////////////////////////////////////////////////////////
//   
//-----------------------------------------------------------------------------
MotionMode::MotionMode()
  {
  Reset();
  }
//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------
MotionMode &MotionMode::operator=(const MotionMode &src)
  {
  IsAtm = src.IsAtm;
  LightMode = src.LightMode;
  HCrit = src.HCrit;
  GrN = src.GrN;
  GrM = src.GrM;
  PList.Clear();

  int i, n = src.GetNPlanet();
  for (i = 0; i < n; i++)
    AddPlanet(src.GetPlanet(i));

  return *this;
  }
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
void MotionMode::AddPlanet(TPlanetId p)
  {
  int k = FindPlanet(p);
  if (k < 0)
    {
    TPlanetId *n = new TPlanetId;
    *n = p;
    PList.Add(n);
    }
  }     
//-----------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------
void MotionMode::DeletePlanet(TPlanetId p)
  {
  int k = FindPlanet(p);
  if (k >= 0)
    PList.Delete(k);
  }     
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
TPlanetId MotionMode::GetPlanet(int i) const
  {
  TAssert(i >= 0 && i < PList.Len());
  return *(PList[i]);
  }
//-----------------------------------------------------------------------------
//       
//-----------------------------------------------------------------------------
void MotionMode::Reset()
  {
  IsAtm = true;
  HCrit = 70e-3;  //  . 
  LightMode = lightNONE;
  PList.Clear();
  AddPlanet(plIdEarth);
  GrN = GrM = 8;
  } 
//-----------------------------------------------------------------------------
//       id
//-----------------------------------------------------------------------------
int MotionMode::FindPlanet(TPlanetId id) const
  {
  int i, n = PList.Len();
  for (i = 0; i < n; i++)
    {
    if (*PList[i] == id)
      return i;
    }

  return -1; 
  }
//-----------------------------------------------------------------------------
//      
//-----------------------------------------------------------------------------
bool MotionMode::IsPlanetSet(TPlanetId p) const
  {
  return FindPlanet(p) >= 0;
  }
///////////////////////////////////////////////////////////////////////////////
