///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
// ,       
///////////////////////////////////////////////////////////////////////////////
#include "MeasData.h"
///////////////////////////////////////////////////////////////////////////////
// ,   
///////////////////////////////////////////////////////////////////////////////
//   
//-----------------------------------------------------------------------------
MeasData::MeasData()
  {
  Type = mtUnknown;
  Size = 0;;
  LatArg = 0;
  Deleted = false;
  }
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
const MeasData &MeasData::operator=(IMeasurement &m)
{
	Type = m.GetType();
	Size = m.GetSize();
	Time = m.GetTime();

	Delta.Init(Size);
	Delta.Init(0.0);
	
	functionals.Init(Size);
	functionals.Init(0.0);

	m.GetRealVector(Meas);
	m.GetMSEVector(PMeas);

	Id = m.GetID();
	StationId = m.GetStationID();
	ObjectId = m.GetObjectID();
	NightId = m.GetNightID();
	PacketId = m.GetPacketID();
	
	m_meas = &m;
	
	lincrt.Init(Size);

	return *this;
}
///////////////////////////////////////////////////////////////////////////////
// ,        
///////////////////////////////////////////////////////////////////////////////
//  
//-----------------------------------------------------------------------------
void MeasDataList::Copy(const MeasDataList &src)
  {
  clear();

  MeasDataEntry *e, *n;

  for (e = src.first(); e != NULL; e = e->next())
    {
    n = new MeasDataEntry;
    *n = *e;
    insert_last(n, 0);
    }
  }
//-----------------------------------------------------------------------------
//    
//-----------------------------------------------------------------------------
MeasDataEntry *MeasDataList::Add(IMeasurement &m)
  {
  MeasDataEntry *n = new MeasDataEntry;
  MeasDataEntry *e;

  *(MeasData *)n = m;

  for (e = first(); e != NULL; e = e->next())
    {
    if (n->Time < e->Time)
      {
      insert_prev(e, n, 0);
      return n;
      }
    }

  insert_last(n, 0);

  return n;
  }
//-----------------------------------------------------------------------------
//    
//-----------------------------------------------------------------------------
const MeasDataEntry *MeasDataList::FindByID(TMeasId id) const
  {
  MeasDataEntry *e;

  for (e = first(); e != NULL; e = e->next())
    {
    if (e->Id == id)
      return e;
    }

  return NULL;
  }
///////////////////////////////////////////////////////////////////////////////
