///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
// ,       
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_MEASDATA_H
#define BNOTOOL_MEASDATA_H
///////////////////////////////////////////////////////////////////////////////
#include "IMeasurement.h"
#include "twll.h"
///////////////////////////////////////////////////////////////////////////////
// ,   
///////////////////////////////////////////////////////////////////////////////
class MeasData
  {
  public:
    //   
    MeasData();
    // 
    virtual ~MeasData()
      {};

    //     
    const MeasData &operator=(IMeasurement &m);
	
	IMeasurement* m_meas;
    //  
    int Type;
    //  
    unsigned Size;
    //  
    TimeJD Time;
    //  
    DVector Meas;
    // MSE 
    DVector PMeas;
    //  
    DVector Delta;
    //  
    TMeasId Id;
    //  
    TSiteId StationId;
	//  
	TNightId NightId;
	// 
	TPacketId PacketId;
    //  
    TObjectId ObjectId;
    //     
	DVector functionals;
  //  double FuncAll;
	//      
//	double FuncActive;
//	int activeCount;
    //   
    double LatArg;
	bool Deleted;
	Vect6 objPos;
	DVector lincrt;
//	DMatrix mm;
//	DMatrix mx;
  };
///////////////////////////////////////////////////////////////////////////////
//          
//  
///////////////////////////////////////////////////////////////////////////////
typedef Twll_Entry_Class<MeasData> MeasDataEntry;
///////////////////////////////////////////////////////////////////////////////
// ,        
///////////////////////////////////////////////////////////////////////////////
class MeasDataList : public Twll_List_Class<MeasDataEntry>
  {
  public:
      //   
    MeasDataList() : Twll_List_Class<MeasDataEntry>() 
      {};
      //  
    MeasDataList(const MeasDataList &src):  Twll_List_Class<MeasDataEntry>()
      { Copy(src);};

      //    
    MeasDataEntry *Add(IMeasurement &m);
      //  
    void Copy(const MeasDataList &src);
      //    
    const MeasDataEntry *FindByID(TMeasId id) const;
  };
///////////////////////////////////////////////////////////////////////////////
#endif
