///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     NEZ
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL__NZEFRAME_H
#define BNOTOOL__NZEFRAME_H
////////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "IFrames.h"
#include "SFramePars.h"
////////////////////////////////////////////////////////////////////////////////
class NZEFrame : public IFrame
  {
  public:
      //   
    NZEFrame()
      {};
      //        
    NZEFrame(const Vect3 &p)
      { Init(p);};

      //        
    NZEFrame & Init(const Vect3 &p)
      { Pars.Init(p); return *this;};
      //     
    virtual const IFrameParameters & GetParameters() const
      { return Pars;};
      //   
    virtual void SetParameters(const IFrameParameters &p);
      //     ?
    virtual bool IsInertial() const
      { return false;};
      //     ?
    virtual bool IsGeocentric() const
      { return false;};

      //  ,        
      //    J2000    t0 ( 3- )
    virtual void Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const; 
      //  ,        
      //    J2000    t0 ( 6- )
    virtual void Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const;
      //  ,        
      //    rf    t0 ( 3- )
    virtual void Get3DConverter(const IFrame &rf, const TimeJD &t0, 
                                FrameConverter3D &result) const;
      //  ,        
      //    rf    t0 ( 6- )
    virtual void Get6DConverter(const IFrame &rf, const TimeJD &t0, 
                                FrameConverter6D &result) const;
      //  ,        
      //      t0 ( 3- )
    void Get3DGreenwichConverter(FrameConverter3D &result) const; 
      //  ,        
      //      t0 ( 6- )
    void Get6DGreenwichConverter(FrameConverter6D &result) const; 

    const Vect3 &GetPoint() const
      { return Pars.GetPoint();};

  protected:
      //  
    NZEFrameParameters Pars;
  };
////////////////////////////////////////////////////////////////////////////////
#endif

