///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     
//   ..
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_ODESTPNSOLVER_H
#define BNOTOOL_ODESTPNSOLVER_H
///////////////////////////////////////////////////////////////////////////////
#include "IODE.h"
///////////////////////////////////////////////////////////////////////////////
class ODEStpnSolver : public IODESolver
  {
  public:
      // 
    ODEStpnSolver();
      // 
    virtual ~ODEStpnSolver();
    
      //   
    virtual void SetSystem(IODESystem* odesystem);
      //    
    void SetParams(const double *eps, double stepinit, double stepmin);
      //   
    virtual void SetInitial(double x, const double* y);

      //       
    virtual bool Run(double x);

      //   
    void SetTrace(bool f = true)
      { IsTrace = f;};

  protected:
      //         
      //  
    double *Eps;
      //  
    double StepInit;
      //   
    double MinStep;   
      //   
    bool IsParamsInit;
      //     
    double *WorkBuffer;
      // , ,   
    bool IsStarted;
      //     (.  + )
    double *Nodes[10];
      //      4 . 
    bool HasCash;
      //      
    double *Phase; 
      //  
    double CurStep;
      //   
    int SVar1, SVar2;
      //    ,   
    double *VTmp1, *VTmp2;
      //    
    double *IVect;
      //  
    bool IsTrace;
      //   
    double Delta;

      //   
    bool Start(int dir);
      //      -
    bool RKStep(const double *y0, double h, double *y, double *f);
      //      
    void InterplateDestPoint(double x, int dir);
      //  
    bool SetNewStep();
      //     
    void ShiftPhase(int dir);
      //   
    bool DoStep(int dir);
      //   
    bool ReverseNodes(int dir);

      // :    
    void Dump();   
  };
///////////////////////////////////////////////////////////////////////////////
#endif

