///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
// ,    c   
// .
//   ,      
// GetSrcFrame()
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_OPTICDELAYMESUREMENT_H
#define BNOTOOL_OPTICDELAYMESUREMENT_H
///////////////////////////////////////////////////////////////////////////////
#include "OpticMeasurement.h"
///////////////////////////////////////////////////////////////////////////////
class OpticDelayMeasurement : public OpticMeasurement
{
public:
	//   
	OpticDelayMeasurement();
	//      
	void SetTimePrecision(double dt)
	{ TimePrec = dt; };
	//       
	double GetTimePrecision() const
	{ return TimePrec;};
	//     
	virtual void SetStationCoords(const Vect3 &pos)
	{ RecPos = pos;};
	//     
	virtual const Vect3 &GetStationCoord() const
	{ return RecPos;};  

	bool PrepareDstFrame(const IFrame &fr);
protected:
	// ,      
	double TimePrec;
	//    t,       ,
	//          
	virtual bool DetectPosition(ITraject &trj, TimeJD &t, const IFrame *fr = NULL, Vect6 *f = NULL) const;
	bool DetectPosition(ITraject &trj, TimeJD &t, Vect6 *f = NULL) const;
	bool DetectPositionEx(ITraject &trj,  TimeJD &t, Vect6& f) const;

	//      f    t
	//   ,   fr
	virtual bool DetectRecieverPos(const TimeJD &t, const IFrame &fr, Vect3 &f) const;
	//     
};
///////////////////////////////////////////////////////////////////////////////
#endif
