///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
// ,       
// .
//   ,      
// GetSrcFrame()
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_OPTICMESUREMENT_H
#define BNOTOOL_OPTICMESUREMENT_H
///////////////////////////////////////////////////////////////////////////////
#include "AFreeMeasurement.h"
///////////////////////////////////////////////////////////////////////////////
class OpticMeasurement : public AFreeMeasurement
{
public:
	//   alpha
	double Alpha;
	//   delta
	double Delta;
	//   alpha
	double PAlpha;
	//   delta
	double PDelta;

	//
	double VAlpha;
	double VDelta;

	//   
	OpticMeasurement() ;
	//     
	virtual unsigned GetSize() const
	{ return 2; };
	//     v  
	virtual void GetRealVector(DVector& v) const ;
	//     v   
	virtual void GetMSEVector(DVector& v) const ;
	//       , 
	//       trj. 
	//    :
	// t	-	,     
	//           (    , 
	//          )
	// fr	-	 ,        
	//        ,      (.   f  m)
	// v	-	   .     0, 
	//          
	// m	-	   Nx6,  N -    
	//      (..    N   6 ).   
	//        Rx Ry Rz Vx  Vy Vz,    -   . 
	//          0,     
	// del	-	   .     0, 
	//           
	virtual bool Simulate(int matrixSize, ITraject &trj, TimeJD &t, const IFrame &fr, Vect6 *f = 0, DVector *v = 0, DMatrix *m = 0, DVector *del = 0) const;

	virtual void Diff(DVector &d, const DVector *m1 = NULL, const DVector *m2 = NULL) const;

//	bool SimulateOrbitAnalyzer(int matrixSize, ITraject &trj, TimeJD &t, const IFrame &fr, Vect6 *f, Vect6 *topo, DVector *v, DMatrix *m, DVector *del) const;

	//	virtual bool Simulate2(ITraject &trj, TimeJD &t, const IFrame &fr, Vect6 *f = 0,
	//		DVector *v = 0, DMatrix *m = 0, DVector *del = 0) const;

//	virtual bool SimulateXXX(int matrixSize, ITraject &trj, TimeJD &t, const IFrame &fr, Vect6 *f = 0, Vect6* ff = 0,
//		DVector *v = 0, DMatrix *m = 0, DVector *del = 0) const;

//	bool SimulateEx(int matrixSize, ITraject &trj, TimeJD &t, Vect6 &f, double* v,  double *del) const;

	virtual bool DetectPositionEx(ITraject &trj, TimeJD &t, Vect6& f) const {return false;};
	//    
	void SetCorrectFlag(bool f)
	{ IsCorrected = f;};
	//    
	bool GetCorrectFlag() const
	{ return IsCorrected;};
	//     
	void Correct(bool newmethod);
	//     
	virtual const Vect3 &GetStationCoord() const = 0;

	Vect3 GetRecPosFr() const {return RecPosFr;}

	virtual void SetIan(unsigned k, bool f = true)
	{ m_isBad = f;};

	virtual bool GetIan(unsigned k) const
	{ return m_isBad;};

	static void AberrationCorrect(double alpha, double delta, TimeJD date, bool backwardCorrection, bool preciseAlgorithm, double& correctedAlpha, double& correctedDelta);
protected:
	//   
	bool IsCorrected; 

	Vect3 RecPosFr;
	bool  RecPosFrInit;
	
	bool m_isBad;
};
///////////////////////////////////////////////////////////////////////////////
#endif
