///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_PHASEPOINT_H
#define BNOTOOL_PHASEPOINT_H
////////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "J2000Frame.h"
////////////////////////////////////////////////////////////////////////////////
  //  
class IPhasePoint
  {
  public:
      // 
	  IPhasePoint(){ 
		  Frame = 0;//new J2000Frame;
	  };
	  IPhasePoint(int dummy): Frame(0){};
	  //  
	  IPhasePoint(const IPhasePoint &src){ 
		  Frame = NULL; Init(src);
	  };
      // 
    virtual ~IPhasePoint();

      // 
    TimeJD T;

      // 
    void Init(const IPhasePoint &src);

      //   
    const IFrame *GetFrame() const
      { return Frame;};
      //   
    IFrame *GetFrame()
      { return Frame;};
      //   
    void SetFrame(const IFrame &f);

    IPhasePoint &operator=(const IPhasePoint &src)
      { Init(src); return *this;};

  protected:
    IFrame *Frame;

  };
////////////////////////////////////////////////////////////////////////////////
  //   
class PhasePoint3D : public IPhasePoint
  {
  public:
      // 
    PhasePoint3D() : IPhasePoint()
      {};
      //  
    PhasePoint3D(const PhasePoint3D &src)
      { Frame = NULL; Init(src);};
      //   
	PhasePoint3D(const IFrame &f, const Vect3 &c, const TimeJD &t):IPhasePoint(666){ 
		Frame = NULL; Init(f, c, t);
	};

      // 
    void Init(const PhasePoint3D &src);
      // 
    void Init(const IFrame &f, const Vect3 &c, const TimeJD &t);

      //  
    PhasePoint3D &operator=(const PhasePoint3D &src)
      { Init(src); return *this;};
    
      //  
    Vect3 Coords;

      //     
    void Convert(const IFrame &f);
      //        
    void Assign(const PhasePoint3D &src);
  };
////////////////////////////////////////////////////////////////////////////////
  //   
class PhasePoint6D : public IPhasePoint
  {
  public:
      // 

	PhasePoint6D(int dummy) : IPhasePoint(dummy)
	  {};
    PhasePoint6D() : IPhasePoint()
      {};
      //  
    PhasePoint6D(const PhasePoint6D &src)
      { Frame = NULL; Init(src);};
      //   
    PhasePoint6D(const IFrame &f, const Vect6 &cv, const TimeJD &t):IPhasePoint(666)
      { Frame = NULL; Init(f, cv, t);};
      //   
    PhasePoint6D(const IFrame &f, const Vect3 &c, const Vect3 &v, const TimeJD &t):IPhasePoint(666)
      { Frame = NULL; Init(f, c, v, t);};

      // 
    void Init(const PhasePoint6D &src);
      // 
    void Init(const IFrame &f, const Vect6 &cv, const TimeJD &t);
      // 
    void Init(const IFrame &f, const Vect3 &c, const Vect3 &v, const TimeJD &t);

      //  
    PhasePoint6D &operator=(const PhasePoint6D &src)
      { 
		  Init(src); return *this;
	};
    
      //  
    Vect6 CoordsVel;

      //     
    void Convert(const IFrame &f);
      //        
    void Assign(const PhasePoint6D &src);
  };
////////////////////////////////////////////////////////////////////////////////
#endif
