///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//     NEZ
////////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL__RNBFRAME_H
#define BNOTOOL__RNBFRAME_H
////////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "IFrames.h"
#include "SFramePars.h"
////////////////////////////////////////////////////////////////////////////////
class RNBFrame : public IFrame
  {
  public:
      //   
    RNBFrame()
      {};
      //       
    RNBFrame(const Vect3 &p, const Vect3 &v)
      { Init(p, v);};
      //       
    RNBFrame(const Vect6 &rv)
      { Init(rv);};

      //       
    RNBFrame & Init(const Vect3 &p, const Vect3 &v)
      { Pars.Init(p, v); return *this;};
      //       
    RNBFrame & Init(const Vect6 &rv)
      { Pars.Init(rv); return *this;};
      //     
    virtual const IFrameParameters & GetParameters() const
      { return Pars;};
      //   
    virtual void SetParameters(const IFrameParameters &p);
      //     ?
    virtual bool IsInertial() const
      { return false;};
      //     ?
    virtual bool IsGeocentric() const
      { return false;};

      //  ,        
      //    J2000    t0 ( 3- )
    virtual void Get3DJ2000Converter(const TimeJD &t0, FrameConverter3D &result) const; 
      //  ,        
      //    J2000    t0 ( 6- )
    virtual void Get6DJ2000Converter(const TimeJD &t0, FrameConverter6D &result) const;

    const Vect3 &GetPoint() const
      { return Pars.GetPoint();};

  protected:
      //  
    RNBFrameParameters Pars;
  };
////////////////////////////////////////////////////////////////////////////////
#endif

