///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//       
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_TMEASUREMENTPACKET_H
#define BNOTOOL_TMEASUREMENTPACKET_H
///////////////////////////////////////////////////////////////////////////////
#include "IMeasurementPacket.h"
#include "twll.h"
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
class IMeasurementRef
  {
  public:
      // 
    IMeasurementRef();
      // 
    virtual ~IMeasurementRef();
      //    
    bool IsActive() const;
	bool IsDeleted() const;
      //   
    IMeasurement *Ref;
      //     ()
    bool ManualFlag;
	bool DeleteFlag;
      //     (
    bool AutoFlag;
  };
///////////////////////////////////////////////////////////////////////////////
//         
///////////////////////////////////////////////////////////////////////////////
typedef Twll_Entry_Class<IMeasurementRef> IMeasurementEntry;
///////////////////////////////////////////////////////////////////////////////
// ,       
///////////////////////////////////////////////////////////////////////////////
class TMeasurementPacket : public Twll_List_Class<IMeasurementEntry>, public IMeasurementPacket
  {
  public:
      //   
    TMeasurementPacket()
      {
      Current = NULL;
      Filter = NULL;
      };
      //      
    virtual unsigned GetSize() const
      {
      return size();
      };
      //   true,    (    )
      //   false   
    virtual bool IsEmpty() const
      {
      return isempty();
      };
      //       
    virtual unsigned GetActiveSize() const;
      //   true,        
      //   false   
    virtual bool IsActive() const;
      //      
    virtual void SetFirst()
      {
      Current = first();
      };
      //      
    virtual void SetLast()
      {
      Current = last();
      };
      //       .
      //    ,     
    virtual void SetFirstActive();
      //       .
      //    ,     
    virtual void SetLastActive();
      //      ,     
      //   t.
      //    ,     
    virtual void SetByTime(const TimeJD &t);
      //       ,   
      //     t.
      //    ,     
    virtual void SetByTimeActive(const TimeJD &t);
      //          m.
      //      ,    .
    virtual void SetCurrent(const IMeasurement &m);
      //           id.
      //      ,    .
    virtual void SetCurrent(TMeasId id);
      //       .
      //     ,   NULL.
    virtual const IMeasurement* GetCurrent() const
      {
      return Current == NULL ? NULL : Current->Ref;
      };

	virtual IMeasurement* GetCurrent()
	{
		return Current == NULL ? NULL : Current->Ref;
	};
      //    ,      
      //   .
      //      ,
      //        .
    virtual void GoNext();
      //    ,     
      //   .
      //      ,
      //        .
    virtual void GoPrev();
      //      ,     
      //    .
      //    ,        .
    virtual void GoNextActive();
      //      ,     
      //    .
      //    ,        .
    virtual void GoPrevActive();
      //      ,    id.
      //      ,    NULL.
      //      .
    virtual const IMeasurement* Find(TMeasId id) const;
      //   true,      (..   )
    virtual bool IsActive(const IMeasurement &m) const;
      //   true,     id   (..   )
    virtual bool IsActive(TMeasId id) const;
      //        m  .
      //    true,     , ,
      //    .
    
	virtual void SetDeleteFlag(const IMeasurement &m, bool f);
	virtual bool GetDeleteFlag(TMeasId id) const;
	virtual bool GetDeleteFlag(const IMeasurement &m) const;

    virtual bool GetManualFlag(const IMeasurement &m) const;
      //        
      //  id  .
      //    true,     , ,
      //    .
    virtual bool GetManualFlag(TMeasId id) const;
      //    f     m  .
      //  f  true,    , ,    .
    virtual void SetManualFlag(const IMeasurement &m, bool f);
      //    f     
      //  id  .
      //  f  true,    , ,    .
    virtual void SetManualFlag(TMeasId id, bool f);
      //        m  .
      //    true,     , ,
      //    .
    virtual bool GetAutoFlag(const IMeasurement &m) const;
      //        
      //  id  .
      //    true,     , ,
      //    .
    virtual bool GetAutoFlag(TMeasId id) const;
      //           
    virtual void ClearAutoFlags();
      //   ,      
    virtual void SetFilter(const IMeasurementFilter *f)
      {
      Filter = f;
      };
      //     ,   
      //   
    virtual const IMeasurementFilter *GetFilter()
      {
      return Filter;
      };
      //         
      //  m.   -  
    virtual void FilterMeasurement(const IMeasurement &m, const DVector &del);
      //   true,      
      //    kmin
      //      
    virtual bool IsEnough(unsigned kmin);

      //    
      //       
    void Add(const IMeasurement *m, bool man_flag = false);

      //       
      //    
    void Create(IMeasurementPacket &src, const TimeJD &t1, const TimeJD &t2);

      //     
    void DeleteInActive();  

  protected:
      //   
    IMeasurementEntry *Current;
      //   ,     
      //  
    const IMeasurementFilter *Filter;
  };
///////////////////////////////////////////////////////////////////////////////
#endif
