/***************************************************************************
 *   Copyright (C) 2008 by Golosova Natalia                                *
 *   nata@allerode                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TRJNUM_H
#define TRJNUM_H
///////////////////////////////////////////////////////////////////////////////
#include "ITraject.h"
#include "DigPredict.h"
///////////////////////////////////////////////////////////////////////////////
class TrjNum : public ITraject
  {
  public:
      // 
    TrjNum();
      // 
    virtual ~TrjNum()
      {};
      //      
    virtual unsigned Size() const
      { return 6;};
      //      
    virtual bool Init(const DVector &u0);
      //      
    virtual void SetTime(const TimeJD &t)
      { InitTime = t;};
      //      
    virtual const TimeJD & GetTime() const
      { return InitTime;};
      //         t.
      //  fr   ,     
      //   f (..   )
    virtual bool Predict(const TimeJD &t, const IFrame &fr, Vect6 &f);
	virtual bool PredictMatrix(const TimeJD &t, const IFrame& fr, Vect6 &f, DMatrix &m){ return 1;} ;
      //       u  
      //   t.
    virtual bool Move(const TimeJD &t, DVector &u);
      //      (  )
    DigStPredict *GetPredictor()
	{ return &Predictor;};
      //       
    void SetKOProp(double kb, double kappa);

  protected:
      //    
    DigStPredict Predictor;
      //    
    TimeJD InitTime;
      // .   
    double Kb;
      //  .   
    double Kappa;     
  };
///////////////////////////////////////////////////////////////////////////////
#endif
