///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//          
//   .     
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_TRJNUMVAR_H
#define BNOTOOL_TRJNUMVAR_H
///////////////////////////////////////////////////////////////////////////////
#include "ITraject.h"
#include "DigPredictVar.h"
///////////////////////////////////////////////////////////////////////////////
class TrjNumVar : public ITrajectVar
  {
  public:
      // 
    TrjNumVar();
      // 
    virtual ~TrjNumVar()
      {};
      //      
    virtual unsigned Size() const;
      //      
    virtual bool Init(const DVector &u0);
      //      
    virtual void SetTime(const TimeJD &t)
      { InitTime = t;};
      //      
    virtual const TimeJD & GetTime() const
      { return InitTime;};

      //         t.
      //  fr   ,     
      //   f (..   )
    virtual bool Predict(const TimeJD &t, const IFrame &fr, Vect6 &f);
      //         t 
      //         .
      //  fr   ,     
      //   f (..   )   m.
    virtual bool PredictMatrix(const TimeJD &t, const IFrame& fr, Vect6 &f, DMatrix &m);
      //       u  
      //   t.
    virtual bool Move(const TimeJD &t, DVector &u);
      //      (  )
    virtual DigStPredictVar *GetPredictor()
      { return &Predictor;};
	virtual IPredict* GetPredictorEx() {return &Predictor;}
      //       
    void SetKOProp(double kb, double kappa, bool is_kb_var = false, bool is_kappa_var = false);

  protected:
      //      
    DigStPredictVar Predictor;
      //    
    TimeJD InitTime;
      // .   
    double Kb;
      //  .   
    double Kappa;
      //   b
    bool IsKbVar;
      //   appa
    bool IsKappaVar;
  };
///////////////////////////////////////////////////////////////////////////////
#endif
