///////////////////////////////////////////////////////////////////////////////
//    
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//   MSGP
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_MSGP_H
#define BNOTOOL_MSGP_H
///////////////////////////////////////////////////////////////////////////////
#include "IPredict.h"
///////////////////////////////////////////////////////////////////////////////
//    TLE-
///////////////////////////////////////////////////////////////////////////////
class TLESet
  {
  public:
      //    
    TLESet()
      { SFlag = false;};

      //      
      //        !!! 
    void SetFromStr(char longstr1[130], char longstr2[130]);
      //   
    void Set();
      //     
    bool IsInit() const
      { return SFlag;};

    const TimeJD GetTime() const
      { return TimeJD(TimeTLE(EpochYr, EpochDays));};

      //  

      //  
    long int Satnum;
      //  
    int EpochYr;
      //   ( )
    double EpochDays;
      // "N  "
    double NDot;
      // "N   "
    double NDDot;
      // "B  "
    double BStar;
      //  
    int ElementNum;
      // 
    double Inclo;
      // 
    double Omegao;
      // 
    double Ecco;
      //  
    double Argpo;
      //  
    double Mo;
      //  
    double No;

      //  

      //  
    double A;
      //  
    double Alta;
      //  
    double Altp;
      // 
    double EpTime;
    double MjdSatEpoch;
  
  protected:
      //    
    bool SFlag;   
  };
///////////////////////////////////////////////////////////////////////////////
//  MSGP-
///////////////////////////////////////////////////////////////////////////////
class MSGPPredict : public IPredict
  {
  public:
      //   
    MSGPPredict() : IPredict()
      { InitFlag = false; Error = 0;};
      //  
    void Init(const TLESet &tle);

      //        
    class NearEarthRecord
      {
      public:
        int Isimp, Method;
        double Aycof  , Con41  , Cc1     , Cc4    , Cc5    , D2      , D3    , D4    ,
               Delmo  , Eta    , Argpdot , Omgcof , Sinmao , T       , T2cof , T3cof ,
               T4cof  , T5cof  , X1mth2  , X7thm1 , Mdot   , Omegadot, Xlcof , Xmcof ,
               Omegacf;
      };

      //        
    class DeepSpaceRecord
      {
      public:
        int Irez;
        double D2201 , D2211 , D3210 , D3222 , D4410 , D4422 , D5220 , D5232 , D5421 ,
               D5433 , Dedt  , Del1  , Del2  , Del3  , Didt  , Dmdt  , Dnodt , Domdt ,
               E3    , Ee2   , Peo   , Pgho  , Pho   , Pinco , Plo   , Se2   , Se3   ,
               Sgh2  , Sgh3  , Sgh4  , Sh2   , Sh3   , Si2   , Si3   , Sl2   , Sl3   ,
               Sl4   , Gsto  , Xfact , Xgh2  , Xgh3  , Xgh4  , Xh2   , Xh3   , Xi2   ,
               Xi3   , Xl2   , Xl3   , Xl4   , Xlamo , Zmol  , Zmos  , Atime , Xli   ,
               Xni;
      };

      //  
    virtual bool Run(const TimeJD &t);
      //   
    virtual void GetDestPoint(PhasePoint6D &dest);

      //   
    int GetError() const
      { return Error;};

  protected:
      //   TLE-
    TLESet TLE; 
      //  
    bool InitFlag;
      //       
    NearEarthRecord Near;
      //       
    DeepSpaceRecord Deep;
      //  
    int Error;
      //    METE
    Vect6 RV;
      //  
    TimeJD Tk;
  };
///////////////////////////////////////////////////////////////////////////////
#endif
