///////////////////////////////////////////////////////////////////////////////
//   
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOLS_PARSECMD_H
#define BNOTOOLS_PARSECMD_H
///////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "tstring.h"
#include <stdio.h>
///////////////////////////////////////////////////////////////////////////////
///     
///////////////////////////////////////////////////////////////////////////////
class TArgsOptions 
  {
  public:
      //  
    const char *OptName; 
      //  true -      , 
      //     =
    bool NeedParam; 
      //  -  .        
      //     Help
    const char *Descr; 
  };
///////////////////////////////////////////////////////////////////////////////
//     
///////////////////////////////////////////////////////////////////////////////
class TArgs 
  {
  public:
      //  
    virtual ~TArgs();                                                
      //    
      // argc -  
      // argv -    
      // onlyOptions - true,        ,
      //                
    bool ParseCmdLine(int argc,
                      const char *argv[],
                      bool onlyOptions=false
                     ); 
      //  . message -    .
    virtual void Help(const char *message);
      //   
      // paramNum -       (  0)
      // paramName -   
      // paramVal -    (  needParam,  NULL)
    virtual bool SetParam(int paramNum,
                          const char *paramName,
                          const char *paramVal=NULL
                          ) = 0;
      //     
    static void SetOptions(TArgsOptions opts[]);              
      //     
    static void PrintUnresolved();                            
      //         (  - stdout)
    static FILE *StreamOut;                                  
      //    
    static int UnResolved_Len;
      //     
    static const char **UnResolved;                                  
  private:
    static TArgsOptions *ArgsOptions;
  };

///////////////////////////////////////////////////////////////////////////////
///         "/@"
///////////////////////////////////////////////////////////////////////////////
void ParseDBAddr(const char *dbline, ///<  
                 TString &dbusername,   ///<   
                 TString &dbuserpass,   ///<   
                 TString &dbaddr        ///<   
                );
///////////////////////////////////////////////////////////////////////////////
#endif
