///////////////////////////////////////////////////////////////////////////////
//   
// ()  " ", 2005 .  
///////////////////////////////////////////////////////////////////////////////
//      
///////////////////////////////////////////////////////////////////////////////
#ifndef KIALIB_TIMERANGE_H
#define KIALIB_TIMERANGE_H
///////////////////////////////////////////////////////////////////////////////
#include "TM.h"
#include "Defines.h"
#include <math.h>
///////////////////////////////////////////////////////////////////////////////
  // ,   
#define MAXJDDATE (TimeJD(9999999, 0))
#define MINJDDATE (TimeJD(0, 0))
///////////////////////////////////////////////////////////////////////////////
class TIME_RANGE
  {
  public:
      //   
    TIME_RANGE(void) 
      { init(); };
      //     
    TIME_RANGE(TimeJD const &beginning, TimeJD const &end)
      { init(); Init(beginning, end); };

      //     
    void Init(TimeJD const &beginning, TimeJD const &in_end);
      //   
    void GetRange(TimeJD &beginning, TimeJD &in_end) const
      { beginning = beg; in_end = end;};
      //   
    TimeJD const & GetRangeBeg(void) const
      { return beg ; };
      //   
    TimeJD const & GetRangeEnd(void) const
      { return end ; };

      //   
    void SetRange(TimeJD const &date_beg, TimeJD const &date_end)
      {  beg = date_beg ;  end= date_end ; init_flag = true;};
      //    
    void SetRangeBeg(TimeJD const &dat)
      { beg = dat; init_flag = true;}
      //    
    void SetRangeEnd(TimeJD const &dat)
      { end = dat ; init_flag = true;};

      //      ?
    bool IsTime(TimeJD const &date) const 
      { return (less_or_equal(beg, date) && greater_or_equal(end, date)); }; 
      
      //    ?
    bool IsClass(void) const 
      { return init_flag;}
    bool operator!(void) const 
      { return !IsClass();}

      //     ?
    bool IsNullBeg() const 
      { return beg == MINJDDATE;};
      //     ?
    bool IsNullEnd() const 
      { return end == MAXJDDATE;};

   protected :
     bool init_flag ;
     TimeJD beg ;
     TimeJD end ;

     void init(void);

  private :
    bool less_or_equal(TimeJD const &__beg, TimeJD const &__date) const;
    bool greater_or_equal(TimeJD const &__beg, TimeJD const &__date) const;
  };
///////////////////////////////////////////////////////////////////////////////
#endif
