///////////////////////////////////////////////////////////////////////////////
//   
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//       
///////////////////////////////////////////////////////////////////////////////
#include "tstring.h"
#include <ctype.h>
#include <cstring>
///////////////////////////////////////////////////////////////////////////////
void TString::TrimLeftChar(char c)
  {
  std::string::iterator p = begin();

  if (*p != c)
    return;

  while (*p == c && p != end())
    p++;

  if (p == end())
    *this = "";
  else
    {
    TString str = "";
    while (p != end())
      {
      str += *p;
      p++;
      }
    *this = str;
    }
  }
//---------------------------------------------------------------------------
void TString::TrimRightChar(char c)
  {
  std::string::reverse_iterator p = rbegin();

  if (*p != c)
    return;

  int l = length();
  while (*p == c && p != rend())
    {
    p++;
    l--;
    }

  if (*p == c)
    *this = "";
  else
    resize(l);
  }
//---------------------------------------------------------------------------
static unsigned char table[] =
  {
  254, /*  192 */
  224, /*  193 */
  225, /*  194 */
  246, /*  195 */
  228, /*  196 */
  229, /* e 197 */
  244, /*  198 */
  227, /*  199 */
  245, /* x 200 */
  232, /*  201 */
  233, /*  202 */
  234, /*  203 */
  235, /*  204 */
  236, /*  205 */
  237, /*  206 */
  238, /*  207 */
  239, /*  208 */
  255, /*  209 */
  240, /*  210 */
  241, /*  211 */
  242, /*  212 */
  243, /*  213 */
  230, /*  214 */
  226, /*  215 */
  252, /*  216 */
  251, /*  217 */
  231, /*  218 */
  248, /*  219 */
  253, /*  220 */
  249, /*  221 */
  247, /*  222 */
  250, /*  223 */
  };
//---------------------------------------------------------------------------
static unsigned char tablek[] =
  {
  193, /*   224*/
  194, /*   225*/
  215, /*   226*/
  199, /*   227*/
  196, /*   228*/
  197, /* e  229*/
  214, /*   230*/
  218, /*   231*/
  201, /*   232*/
  202, /*   233*/
  203, /*   234*/
  204, /*   235*/
  205, /*   236*/
  206, /*   237*/
  207, /*   238*/
  208, /*   239*/
  210, /*   240*/
  211, /*   241*/
  212, /*   242*/
  213, /*   243*/
  198, /*   244*/
  200, /* x  245*/
  195, /*   246*/
  222, /*   247*/
  219, /*   248*/
  221, /*   249*/
  223, /*   250*/
  217, /*   251*/
  216, /*   252*/
  220, /*   253*/
  192, /*   254*/
  209, /*   255*/
  };
//---------------------------------------------------------------------------
static unsigned char FromDOSToKOI(unsigned char s)
  {
  if (s < 128)
    return s;
  else if (s < 160)
    return tablek[s - 128] + 32;
  else if (s < 192)
    return tablek[s - 160];
  return s;
  }
//---------------------------------------------------------------------------
unsigned char ToWin(unsigned char s)
  {
  if (s < 192)
    return s;
  else if (s < 224)
    return table[s - 192];
  else return table[s - 224] - 32;
  }
//---------------------------------------------------------------------------
unsigned char ToKOI(unsigned char s)
  {
#if defined(_WIN32) || defined(_WINDOWS) || defined(_Windows)
  if (s < 192)
    return s;
  if (s < 224)
    return tablek[s - 192] + 32;
  return tablek[s - 224];
#else
  return s;
#endif
  }
//---------------------------------------------------------------------------
int cmpstr(const char *str1, const char *str2)
  {
#if defined(_WIN32) || defined(_WINDOWS) || defined(_Windows)
  return strcmp(str1, str2);
#else
  unsigned const char *s1, *s2;

  for (s1 = (unsigned const char *)str1, s2 = (unsigned const char *)str2;
       *s1 != '\0' && *s2 != '\0'; s1++, s2++)
    {
    if (ToWin(*s1) < ToWin(*s2))
      return -1;
    if (ToWin(*s1) > ToWin(*s2))
      return 1;
    }

  if (*s1 != '\0')
    return 1;

  if (*s2 != '\0')
    return -1;

  return 0;
#endif
  }
//---------------------------------------------------------------------------
void TString::ToWin()
  {
  if (empty())
    return;

  std::string::iterator p;

  for (p = begin(); p != end(); p++)
    *p = ::ToWin(*p);
  }
//---------------------------------------------------------------------------
void TString::ToKOI()
  {
  if (empty())
    return;

  std::string::iterator p;

  for (p = begin(); p != end(); p++)
    *p = ::ToKOI(*p);
  }
//---------------------------------------------------------------------------
void TString::FromDOSToKOI()
  {
  if (empty())
    return;

  std::string::iterator p;

  for (p = begin(); p != end(); p++)
    *p = ::FromDOSToKOI(*p);
  }
//---------------------------------------------------------------------------
void TString::MakeLower()
  {
  if (empty())
    return;

  std::string::iterator p;

  for (p = begin(); p != end(); p++)
    *p = tolower(*p);
  }
///////////////////////////////////////////////////////////////////////////////
