///////////////////////////////////////////////////////////////////////////////
//   
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//       
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_STRING_H
#define BNOTOOL_STRING_H
///////////////////////////////////////////////////////////////////////////////
#include <string>
///////////////////////////////////////////////////////////////////////////////
typedef std::string bstring; //    MS VC++ 6.0
///////////////////////////////////////////////////////////////////////////////
//     
class TString : public bstring
  {
  public:
    //   
    TString();
    // 
    TString(const char *str);
    //  
    TString(const TString &str);
    // 
    TString(const char c);
    // 
    TString(const char *str, unsigned n) : bstring(str, n) {};
    //    const char *
    operator const char *() const
      { return c_str();};
    //   (    . )
    void SetBuffer(unsigned n) 
      {};
	
    unsigned GetLength() const
      { return (unsigned)length();};
    //   
    unsigned Length() const
      { return (unsigned)length();};
    //   
    bool IsEmpty() const
      { return empty();};
    //     
    char GetChar(int k) const
      { return at(k);};
    //  
    int FindChar(char c) const
      { return (int)find(c);};
    //    
    TString Left(unsigned n) const
      { return TString(c_str(), n);};
    //    
    void TrimLeftChar(char c);
    //   
    void TrimLeft()
      { TrimLeftChar(' ');};
    //    
    void TrimRightChar(char c);
    //   
    void TrimRight()
      { TrimRightChar(' ');};
    //   Windows-1251
    void ToWin();
    //   8
    void ToKOI();
    //   DOS  8
    void FromDOSToKOI();
    //      
    void MakeLower();
    //  
    friend TString operator+(const TString& string1,
      const TString& string2);
    friend TString operator+(char c1, const TString& string2);
    friend TString operator+(const TString& string1, char c2);
    friend TString operator+(const TString& string1, const char *str2);
    friend TString operator+(const char *str1, const TString& string2);
  };
///////////////////////////////////////////////////////////////////////////////
//  inline   TString
///////////////////////////////////////////////////////////////////////////////
inline TString::TString() : bstring("")
  {};
//---------------------------------------------------------------------------
inline TString::TString(const char *str) : bstring(str == NULL ? "" : str)
  {};
//---------------------------------------------------------------------------
inline TString::TString(const TString &str) : bstring(str)
  {};
//---------------------------------------------------------------------------
inline TString::TString(const char c) : bstring(1, c)
  {};
///////////////////////////////////////////////////////////////////////////////
//  inline   TString
///////////////////////////////////////////////////////////////////////////////
inline TString operator+(const TString& string1,  const TString& string2)
  {
  TString res = string1;
  res += string2;
  return res;
  }
//---------------------------------------------------------------------------
inline TString operator+(char c1, const TString& string2)
  {
  TString res = c1;
  res += string2;
  return res;
  }
//---------------------------------------------------------------------------
inline TString operator+(const TString& string1, char c2)
  {
  TString res = string1;
  res += c2;
  return res;
  }
//---------------------------------------------------------------------------
inline TString operator+(const char *str1, const TString& string2)
  {
  TString res = str1;
  res += string2;
  return res;
  }
//---------------------------------------------------------------------------
inline TString operator+(const TString& string1, const char *str2)
  {
  TString res = string1;
  res += str2;
  return res;
  }
///////////////////////////////////////////////////////////////////////////////
//   
///////////////////////////////////////////////////////////////////////////////
int cmpstr(const char *str1, const char *str2);
//    Windows-1251
unsigned char ToWin(unsigned char s);
//    8
unsigned char ToKOI(unsigned char s);
///////////////////////////////////////////////////////////////////////////////
#endif
