///////////////////////////////////////////////////////////////////////////////
//   
// ()  ...,  ""
///////////////////////////////////////////////////////////////////////////////
//        
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_TWLL_H
#define BNOTOOL_TWLL_H
///////////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
///////////////////////////////////////////////////////////////////////////////
  //     
class CTwll_BEntry_Class
  {
  public:
      // 
    CTwll_BEntry_Class()
      { next = prev = NULL; ident = 0;};
      // 
    virtual ~CTwll_BEntry_Class() 
      {};
      //    
    class CTwll_BEntry_Class *next;
      //    
    class CTwll_BEntry_Class *prev;
      //  
    unsigned  ident;
  }; 
typedef class CTwll_BEntry_Class TWLL_BENTRY_CLASS;
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
class CTwll_BList_Class
  {
  public:
      // 
    CTwll_BList_Class();
      // 
    virtual ~CTwll_BList_Class()
      {};
      //    
    void delete_node(TWLL_BENTRY_CLASS *el);
      //    
    void insert_prev(TWLL_BENTRY_CLASS *Cur, TWLL_BENTRY_CLASS *New, unsigned id = 0);
      //    
    void insert_next(TWLL_BENTRY_CLASS *Cur, TWLL_BENTRY_CLASS *New, unsigned id = 0);
      //     
    void insert_last(TWLL_BENTRY_CLASS *New, unsigned id = 0);
      //     
    void moveto_last(TWLL_BENTRY_CLASS *Cur);
      //     
    void insert_first(TWLL_BENTRY_CLASS *New, unsigned id = 0);
      //     
    void moveto_first(TWLL_BENTRY_CLASS *Cur);
      //      
    TWLL_BENTRY_CLASS  *search_id(unsigned id) const;
      //      
    void delete_id(unsigned id);
      //    
    bool isempty() const;
      //    
    bool isown(TWLL_BENTRY_CLASS *e);
      //   (   )
    unsigned size() const;
      //      
    void sort(int compare(TWLL_BENTRY_CLASS *,TWLL_BENTRY_CLASS *));
      //    
    TWLL_BENTRY_CLASS  *pfirst;
      //    
    TWLL_BENTRY_CLASS  *plast;

  private:
      //     
    void swap(TWLL_BENTRY_CLASS *,TWLL_BENTRY_CLASS *);
      //         
    TWLL_BENTRY_CLASS *set_number(int k);
  }; 
typedef class Twll_BList_Class TWLL_BLIST_CLASS;
///////////////////////////////////////////////////////////////////////////////
//    
///////////////////////////////////////////////////////////////////////////////
template<class ENTRY> class Twll_List_Class: public CTwll_BList_Class
  {
  public:
      // 
    virtual ~Twll_List_Class()
      { clear(); }
      //     
    ENTRY *first() const
      { return (ENTRY *)(CTwll_BList_Class::pfirst); }
      //     
    ENTRY *last() const
      { return (ENTRY *)(CTwll_BList_Class::plast); }
      //      
    ENTRY *search_id(unsigned id) const
      { return (ENTRY *)(CTwll_BList_Class::search_id(id)); }
      //    
    void delete_node(ENTRY *e)
      { CTwll_BList_Class::delete_node(e); delete e;};
      //  
    void clear()
      {
      ENTRY *cur, *prev;

      cur = last();
      while (cur != NULL)
        {
        prev = cur->prev();
        delete cur;
        cur = prev;
        }

      pfirst = plast = NULL;
      return;
      };
  };
///////////////////////////////////////////////////////////////////////////////
//     
///////////////////////////////////////////////////////////////////////////////
template <class BASE> class Twll_Entry_Class:
  public CTwll_BEntry_Class, public BASE
  {
  public:
      //     
    Twll_Entry_Class *next() const { return (Twll_Entry_Class *)
      (CTwll_BEntry_Class::next); }
      //     
    Twll_Entry_Class *prev() const
      { return (Twll_Entry_Class *)(CTwll_BEntry_Class::prev); }
      // 
    virtual ~Twll_Entry_Class() {};
  };
#endif
///////////////////////////////////////////////////////////////////////////////
