#include "AtmModel.h"
#include "XMLFunctions.h"
#include <map>

AtmModel::AtmModel()
:m_model("ATM_NONE")
{
}

AtmModel::AtmModel(std::string model, std::string kpmodel)
:
m_model(model),
m_kpModel(kpmodel)
{
}

bool AtmModel::Load(myXML::Contain *parent)
{
	std::map<std::string,myXML::Contain*> con;
	GetChildren(parent,con);

	LoadXML(con,"Model",m_model);
	if (m_model != "ATM_NONE"){
		LoadXML(con,"KpModel",m_kpModel);
	}

	return true;
}

void AtmModel::load(const jsonval& parent)
{
	loadjson(parent, "model", m_model);
	
	if (m_model != "ATM_NONE"){
		loadjson(parent, "kp", m_kpModel);
	}
}
