#ifndef KEPLERTRJ_H
#define KEPLERTRJ_H

#include "ITraject.h"
#include "KeplPredict.h"

class KeplerTrj : public ITraject
  {
  public:
      // 
    KeplerTrj();
      // 
    virtual ~KeplerTrj()
      {};
      //      
    virtual bool Init(const DVector &u0);
      //      
    virtual void SetTime(const TimeJD &t)
      { InitTime = t;};
      //      
    virtual const TimeJD& GetTime() const
      { return InitTime;}
      //         t.
      //  fr   ,     
      //   f (..   )
    virtual bool Predict(const TimeJD &t, const IFrame &fr, Vect6 &f);
//	bool PredictEx(const TimeJD &t, Vect6 &f);
      //         t 
      //         .
      //  fr   ,     
      //   f (..   )   m.
    virtual bool PredictMatrix(const TimeJD &t, const IFrame& fr, Vect6 &f, DMatrix &m);
      //       u  
      //   t.
    virtual bool Move(const TimeJD &t, DVector &u);
	
	virtual IPredict* GetPredictorEx() {return &Predictor;}
	//      (  )
	KeplPredict *GetPredictor()
      { return &Predictor;};
      //       
	
	virtual unsigned Size() const;
  protected:
      //      
    KeplPredict Predictor;
      //    
    TimeJD InitTime;
      // .   
    double Kb;
      //  .   
    double Kappa;
      //   b
    bool IsKbVar;
      //   appa
    bool IsKappaVar;
  };
///////////////////////////////////////////////////////////////////////////////
#endif
