#ifndef PROGNOZ_H
#define PROGNOZ_H

#include "ITraject.h"
#include "PrognozPredict.h"

class PrognozTrj : public ITraject
{
public:
	// 
	PrognozTrj();
	// 
	virtual ~PrognozTrj()
	{};
	//      
	virtual bool Init(const DVector &u0);
	//      
	virtual void SetTime(const TimeJD &t)
	{ InitTime = t;};
	//      
	virtual const TimeJD& GetTime() const
	{ return InitTime;};
	//         t.
	//  fr   ,     
	//   f (..   )
	virtual bool Predict(const TimeJD &t, const IFrame &fr, Vect6 &f);
	virtual bool PredictA(const TimeJD &t, Vect6 &f);
	//         t 
	//         .
	//  fr   ,     
	//   f (..   )   m.
	virtual bool PredictMatrix(const TimeJD &t, const IFrame& fr, Vect6 &f, DMatrix &m);
	//       u  
	//   t.
	virtual bool Move(const TimeJD &t, DVector &u);

	virtual IPredict* GetPredictorEx() {return &Predictor;}
	//      (  )
	PrognozPredict *GetPredictor()
	{ return &Predictor;};
	//       
	
	virtual unsigned Size() const;

	void SetPeriodChangePerRev(double value){m_periodChangePerRev = value;}
protected:
	//      
	PrognozPredict Predictor;
	//    
	TimeJD InitTime;
	// .   
	double Kb;
	//  .   
	double Kappa;
	//   b
	bool IsKbVar;
	//   appa
	bool IsKappaVar;

	double m_periodChangePerRev; // period drop per revolution in mimutes
};
///////////////////////////////////////////////////////////////////////////////
#endif
