#ifndef SGPTRJ_H
#define SGPTRJ_H

#include "ITraject.h"
#include "msgp.h"

class SGPTrj : public ITraject
{
public:
	// 
	SGPTrj();
	// 
	virtual ~SGPTrj()
	{};
	//      
	virtual bool Init(const DVector &u0);
	virtual bool Init(const TLESet &tle);
	//      
	virtual void SetTime(const TimeJD &t)
	{ InitTime = t;};
	//      
	virtual const TimeJD& GetTime() const
	{ return InitTime;};
	//         t.
	//  fr   ,     
	//   f (..   )
	virtual bool Predict(const TimeJD &t, const IFrame &fr, Vect6 &f);
	virtual bool PredictA(const TimeJD &t, Vect6 &f);
	//         t 
	//         .
	//  fr   ,     
	//   f (..   )   m.
	virtual bool PredictMatrix(const TimeJD &t, const IFrame& fr, Vect6 &f, DMatrix &m){return true;};
	//       u  
	//   t.
	virtual bool Move(const TimeJD &t, DVector &u);
	//      (  )
	MSGPPredict *GetPredictor()
	{ return &Predictor;};
	//       
	virtual unsigned Size() const;
protected:
	//      
	MSGPPredict Predictor;
	//    
	TimeJD InitTime;
	// .   
};
///////////////////////////////////////////////////////////////////////////////
#endif
