#ifndef INTEGRATORCFG_H
#define INTEGRATORCFG_H 

#define IEPS 1E-9
#define ISTEPINIT 10E-3
#define ISTEPMIN .1E-3

class IntegratorCfg{
public:
	IntegratorCfg()	:
	  m_eps(IEPS), m_stepinit(ISTEPINIT), m_stepmin(ISTEPMIN), m_precItrf(false)
	  {
	  }

	  IntegratorCfg(double eps, double stepinit, double stepmin, bool precItrf):
	  m_eps(eps), m_stepinit(stepinit), m_stepmin(stepmin), m_precItrf(precItrf)
	  {
	  }

	  double getEps() const{return m_eps > 0 ? m_eps : IEPS;}
	  double getStepInit() const{return m_stepinit > 0 ? m_stepinit : ISTEPINIT;}
	  double getStepMin() const{return m_stepmin > 0 ? m_stepmin : ISTEPMIN;}
	  bool getPrecItfr() const{return m_precItrf;}
private:
	double m_eps;
	double m_stepinit;
	double m_stepmin;
	bool m_precItrf;
};


#endif
