﻿#pragma once

#include "StateVector.h"
#include "TM.h"
#include "ephi.h"
#include "DVectors.h"
#include "Propagator.h"
#include "ires.h"

class XInterpolator{
public:
	XInterpolator();
	XInterpolator(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end);
	~XInterpolator();
	void create(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end);
	bool get_pos(const TimeJD& date, Vect6& res) const;
	int get_size() const {return m_positions.size();}
	TimeJD get_beg() const {return m_beg;}
	TimeJD get_end() const {return m_end;}
	const SInitOrbit& get_orbit() const {return m_orbit;}
private:
	static void calc_positions(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end, std::vector<IRes>& result);
	static void propagate(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end, int dir, std::vector<IRes>& result);
	static void propagate_dir(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end, int dir, std::vector<IRes>& result);
	//void filter_addons();

	TimeJD m_beg;
	TimeJD m_end;
	ei* m_ephi;
	std::vector<IRes> m_positions;
	SInitOrbit m_orbit;
};

