﻿#pragma once

#include "TM.h"
#include <vector>
#include "orbBlock.h"
#include "StateVector.h"
#include "interpolate.h"

typedef std::vector<OrbBlock> OrbBlocks;

class OrbBlocksStore
{
public:
	OrbBlocksStore(){};
	~OrbBlocksStore();
	void init(const SInitOrbits& orbits, const TimeJD& beg, const TimeJD& end);
	bool get_pos(const TimeJD& date, Vect6& result) const;
	const SInitOrbit& get_orbit(const TimeJD& date) const;
	const OrbBlocks& get_blocks() const {return m_blocks;}
private:
	void init_min_dist(const SInitOrbits& orbits, const TimeJD& startDate, const TimeJD& endDate);
	void calc_min_dist(const SInitOrbit& orb1, const SInitOrbit& orb2, const TimeJD& beg, const TimeJD& end, TimeJD& result_jd, double& result_dist);
	SInitOrbits filter(SInitOrbits orbits) const;
	OrbBlocks m_blocks;
	std::vector<XInterpolator*> m_interpolators;
};
